0a1,5
> /*
> static char sccsid[] = "@(#)70  1.1  src/com/ibm/cim/CIMDateTime.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:07";
> */
> 
> //------------------------------------------------------------------------------
2c7
< // CIMDateTime.java
---
> // Filename: CIMDateTime.java
4,6c9
< // The contents of this file are subject to the SNIA Public License Version 1.0
< // (the "License"); you may not use this file except in compliance with the
< // License. You may obtain a copy of the License at
---
> // Description: This represents a date
8c11
< //	http://www.snia.org/resources/openSource.html
---
> // Change History:
10,64c13,17
< // Software distributed under the License is distributed on an "AS IS" basis,
< // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
< // License for the specific language governing rights and limitations
< // under the License.
< //
< // The Original Code is CIMDataType.java
< // 
< // The Initial Developer of the Original Code is David Simons.
< //
< // Contributor(s): Dan Dahl
< //		   Andrei Viktorov ProdEx Technologies
< //
< //
< // This source uses the Solaris WBEM APIs version 2.2. 
< // Synchronization will be maintained with the Solaris WBEM APIS,
< // which are being standardized through the Java Community Process.
< //
< //
< // $Id: CIMDateTime.java,v 1.7 2001/07/01 11:11:49 davidsi Exp $
< //
< // $Log: CIMDateTime.java,v $
< // Revision 1.7  2001/07/01 11:11:49  davidsi
< // - The UTCoffset was not being calculated properly in many cases
< //   (from Robert St Jacques).
< //
< // Revision 1.2  2001/06/28 15:11:39  rstjacqu
< // fixed errors with time zones and DST offsets.
< //
< // Revision 1.1.1.1  2001/04/17 14:33:39  rstjacqu
< // no message
< //
< // Revision 1.6  2001/03/20 13:10:52  davidsi
< // - Changed instantiation exceptions to illegal argument.
< // - Fixed hours being inserted into string twice.
< //
< // Revision 1.5  2001/03/19 17:32:49  davidsi
< // - Fixed problems whereby the timezone on the running machine could
< //   affect the results comming back from a CIMDateTime instance.
< //
< // Revision 1.4  2001/01/16 19:24:54  davidsi
< // - For Andrei Viktorov. Further fixes to time handling.
< //
< // Revision 1.3  2001/01/07 16:43:45  davidsi
< // - Added kludge for handing '*' in date/time strings.
< //
< // Revision 1.2  2001/01/02 19:29:13  davidsi
< // - Fixed parsing of date/time strings.
< //
< // Revision 1.1  2000/11/06 17:49:52  davidsi
< // - Initial version.
< //
< //
< //
< //
< package org.snia.wbem.cim;
---
> //	Modifier			Date				Change ID
> // ------------------------------------------------------------------------------
> // Darshan Vora 			06-12-2002
> //	Initial creation
> //-------------------------------------------------------------------------------
65a19,21
> package com.ibm.cim;
> 
> 
67,68d22
< import java.io.Serializable;
< import java.util.GregorianCalendar;
70a25
> import java.io.Serializable;
71a27
> public class CIMDateTime implements Serializable {
73,78c29,38
< /**
<  *
<  * Stores CIM dates and times 
<  *  
<  */
< public class CIMDateTime extends Object implements Serializable {
---
> 	private static String GMT = "GMT";
> 	private static int UTC_MULTIPLIER = 60000;
> 
> 	private int UTCOffset = 0;
> 	private	boolean 	isInterval = false;
> 	private Calendar 	cal = null;
> 	private String  	dateTime = null;
> 
> 
> 
80c40
< 	 * Used to adjust the UTC offset.
---
> 	 *	Constructor - creates CIMDateTime object
82,83c42,45
< 	private static final int UTC_MULTIPLIER = 60000;
< 	
---
> 	public CIMDateTime(){
> 		this(new Date());
> 	}
> 
85,86c47
< 	 * All dates are converted to Greenwich Mean Time to maintain an absolute 
< 	 * time standard.
---
> 	 *	Constructor - creates CIMDateTime object
88c49
< 	private static final String GREENWICH_MEAN_TIME = "GMT";
---
> 	public CIMDateTime(Date dateObj){
90,103c51,57
<     int UTCoffset=0;
<     boolean intervalSet=false;	
< 	//the calendar should be set to greenwich mean time
<     Calendar cal=Calendar.getInstance( 
< 		TimeZone.getTimeZone( GREENWICH_MEAN_TIME ));
<     /*
<      * realCal factors the time zone into its values so that the offset
<      * is reset to 0.
<      */
<     Calendar realCal = null;
<     int days=0;
<     int hours;	int mins;
<     int secs;
<     int milliseconds;
---
> 		Calendar tempCal = Calendar.getInstance( TimeZone.
> 											getTimeZone(GMT));
> 		tempCal.setTime(dateObj);					
> 		cal = (Calendar)tempCal.clone();
> 		UTCOffset = ( tempCal.get(Calendar.ZONE_OFFSET) /UTC_MULTIPLIER);
> 		dateTime = getDateString();
> 	}
106,110c60,79
<    /**
<     * Constructor
<     */
<     public CIMDateTime() {
<     }	
---
> 	/**
> 	 *	Constructor - creates CIMDateTime object
> 	 */
> 	public CIMDateTime(Calendar calObj){
> 	/*
> 		Calendar tempCal = Calendar.getInstance( TimeZone.
> 							getTimezone(GMT));
> 		cal = tempCal.clone();
> 		tempCal.set(Calendar.YEAR,calObj.get(Calendar.YEAR));
> 		tempCal.set(Calendar.MONTH,calObj.get(Calendar.MONTH));
> 		tempCal.set(Calendar.DAY_OF_MONTH,calObj.get(Calendar.DAY_OF_MONTH));
> 		tempCal.set(Calendar.HOUR,calObj.get(Calendar.HOUR));
> 		tempCal.set(Calendar.MINUTE,calObj.get(Calendar.MINUTE));
> 		tempCal.set(Calendar.SECOND,calObj.get(Calendar.SECOND));
> 		tempCal.set(Calendar.MILLISECOND,calObj.get(Calendar.MILLISECOND));
> 		tempCal.set(Calendar.ZONE_OFFSET,calObj.get(Calendar.ZONE_OFFSET));
> 	*/
> 		UTCOffset = ( calObj.get(Calendar.ZONE_OFFSET) /UTC_MULTIPLIER);
> 		cal = (Calendar) calObj.clone();
> 		dateTime = this.getDateString();
112,121c81
<    /**
<     * Builds a CIMDateTime from an existing date
<     * 
<     * @param inDate The date to initialize the CIMDateType from
<     */
<     public CIMDateTime(Date inDate) {
< 	cal.setTime(inDate);
< 	realCal = (Calendar)cal.clone();
< 	UTCoffset= ( cal.get(Calendar.ZONE_OFFSET) / UTC_MULTIPLIER );
<     }
---
> 	}	
123,139d82
<     /**
<      * Builds a CIMDateTime from an existing Calendar instance
<      * 
<      * @param inCal The caldendar to build from
<      */
<     public CIMDateTime(Calendar inCal) {
< 	cal.set(Calendar.YEAR,cal.get(Calendar.YEAR));
< 	cal.set(Calendar.MONTH,cal.get(Calendar.MONTH));
< 	cal.set(Calendar.DAY_OF_MONTH,cal.get(Calendar.DAY_OF_MONTH));
< 	cal.set(Calendar.HOUR,cal.get(Calendar.HOUR));
< 	cal.set(Calendar.MINUTE,cal.get(Calendar.MINUTE));
< 	cal.set(Calendar.SECOND,cal.get(Calendar.SECOND));
< 	cal.set(Calendar.MILLISECOND,cal.get(Calendar.MILLISECOND));
< 	cal.set(Calendar.ZONE_OFFSET,cal.get(Calendar.ZONE_OFFSET));
< 	UTCoffset= ( cal.get(Calendar.ZONE_OFFSET) / UTC_MULTIPLIER );
< 	realCal = (Calendar)cal.clone();
<     }
141,148c84,91
<    /**
<     * Builds a CIMDateTime from a String that is compliant with the
<     * CIM specification for absolute or interval date/times
<     * 
<     * @param inStr The date/time as defined by the CIM specification
<     * 
<     */
<     public CIMDateTime(String inStr) {
---
> 	/**
> 	 *	Constructor - creates CIMDateTime object
> 	 */
> 	public CIMDateTime(String str){
> 		if (str.length() == 0) {
> 			dateTime = str;
> 			return;
> 		}
150,154c93,100
< 	//
< 	// TODO - this is a temporary workaround until it can
<  	// be determined exactly what a '*' should do
< 	//
< 	inStr = inStr.replace('*','0');
---
> 		int hour,minute,second,millisecond,year,month,day;
> 		boolean valid = true;
> 		//check for valid length
> 		if((str.length() != 25)|| (str.charAt(14)!='.')) {
> 			throw new IllegalArgumentException(str+ "has Invalid format");
> 		}
> 		// replace asterics with 0's
> 		str = str.replace('*','0');
156,162c102,159
< 	if (inStr.length()!=25) {
< 	    // Pam Wright, Imation Change InstantiationError to
< 	    // IllegalArgumentException InstantiationError did not
< 	    // get handled properly because it is not an exception
< 	    // IllegalArgument is a more appropriate class to
< 	    // characterize the problem.
< 	    throw new IllegalArgumentException(inStr+" is not a valid CIM date (bad length)");
---
> 		//date has to be in format:
> 		//	yyyymmddhhmmss.mmmmmmsutc
> 		//if it is in interval then format has to be
> 		//	dddddddhhhmmss.mmmmmm:000
> 
> 
> 		char delimiter = str.charAt(21);
> 		//parse for offset
> 		try {
> 			int offset = Integer.parseInt(str.substring(22,25));
> 
> 			if( delimiter == ':'){
> 				// date is in interval  format
> 				isInterval = true;
> 
> 				//offset has to be 000
> 				if (offset !=0)
> 					valid = false;
> 
> 				year=month=day=0;
> 
> 			}else {
> 				if (delimiter == '+') {
> 					UTCOffset = offset;
> 				}	
> 				else if (delimiter == '-') {
> 					UTCOffset = -offset;
> 				} else {
> 					valid = false;
> 				}
> 				//date is not in interval format
> 				isInterval = false;
> 
> 				//parse year,month and date
> 				//TODO :  validation
> 				year = Integer.parseInt(str.substring(0,4));
> 				month = Integer.parseInt(str.substring(4,6))-1;
> 				day = Integer.parseInt(str.substring(6,8));
> 			}
> 			hour = Integer.parseInt(str.substring(8,10));	
> 			minute = Integer.parseInt(str.substring(10,12));	
> 			second = Integer.parseInt(str.substring(12,14));	
> 			millisecond = Integer.parseInt(str.substring(15,21));	
> 				
> 			if(!valid){
> 				throw new IllegalArgumentException(str+" has Invalid date");
> 			}	
> 
> 			Calendar tempCal = Calendar.getInstance( TimeZone.
> 											getTimeZone(GMT));
> 			tempCal.set(year,month,day,hour,minute,second);						
> 			tempCal.set(Calendar.MILLISECOND,millisecond);
> 			cal = (Calendar)tempCal.clone();
> 			cal.set(Calendar.DST_OFFSET, UTCOffset * UTC_MULTIPLIER);
> 		}catch (Exception e ){
> 			throw new IllegalArgumentException(str+" has Invalid date");
> 		}
> 		dateTime = str;
164,195c161,179
< 	//
<     	// Expect date to be in the format:
< 	// yyyymmddhhmmss.mmmmmmsutc
<     	// if it represents an absolute value
< 	// or yyyymmddhhmmss.mmmmmm:000 for intervals
<     	//
< 	try {
< 	    int offset=Integer.parseInt(inStr.substring(22,25));
< 	    char sign=inStr.charAt(21);
< 	    if (sign==':') {
< 		if (offset!=0) {
< 		    // Pam Wright, Imation Change InstantiationError to
< 		    // IllegalArgumentException InstantiationError did not
< 		    // get handled properly because it is not an exception
< 		    // IllegalArgument is a more appropriate class to
< 		    // characterize the problem.
< 		    throw new IllegalArgumentException(inStr+" is not a valid CIM interval");
<     		}
<     	        intervalSet=true;
< 	    }
< 	    hours=Integer.parseInt(inStr.substring(8,10));
< 	    mins=Integer.parseInt(inStr.substring(10,12));
< 	    secs=Integer.parseInt(inStr.substring(12,14));
< 	    milliseconds=Integer.parseInt(inStr.substring(15,21));
< 	    if (!intervalSet) {
< 		int year=Integer.parseInt(inStr.substring(0,4));
< 		int month= (Integer.parseInt(inStr.substring(4,6)))-1;
< 		int day=Integer.parseInt(inStr.substring(6,8));
< 		if (sign=='+') {
< 		    UTCoffset=offset;
< 		} else if (sign=='-') {
< 		    UTCoffset =-offset;
---
> 
> 
> 	/**
> 	 *	returns string representation of date form calender
> 	 */
> 	private String getDateString() {
> 		StringBuffer newString = new StringBuffer();
> 		newString.append(padZero(4,this.cal.get(Calendar.YEAR)));
> 		newString.append(padZero(2,this.cal.get(Calendar.MONTH)+1));
> 		newString.append(padZero(2,this.cal.get(Calendar.DAY_OF_MONTH)));
> 		newString.append(padZero(2,this.cal.get(Calendar.HOUR)));
> 		newString.append(padZero(2,this.cal.get(Calendar.MINUTE)));
> 		newString.append(padZero(2,this.cal.get(Calendar.SECOND)));
> 		newString.append(".");
> 
> 		//millisecond to microsecond
> 		newString.append(padZero(6,this.cal.get(Calendar.MILLISECOND)));
> 		if (UTCOffset > 0) {
> 			newString.append("+");
197,202c181
< 		    // Pam Wright, Imation Change InstantiationError to
< 		    // IllegalArgumentException InstantiationError did not
< 		    // get handled properly because it is not an exception
< 		    // IllegalArgument is a more appropriate class to
< 		    // characterize the problem.
< 		    throw new IllegalArgumentException(inStr+" is not a valid CIM date because the UTC must be preceeded by +/-");
---
> 			newString.append("-");
203a183
> 		newString.append(padZero(3,UTCOffset));
205,220c185
< 		cal.setTimeZone(TimeZone.getTimeZone( GREENWICH_MEAN_TIME ));	
< 		cal.set(year,month,day,hours,mins,secs);
< 		cal.set(Calendar.MILLISECOND,milliseconds);
< 		
< 		realCal=(Calendar)cal.clone();
< 		realCal.set(Calendar.DST_OFFSET,UTCoffset*UTC_MULTIPLIER);
< 	    } else {
< 		days=Integer.parseInt(inStr.substring(0,8));
< 	    }
< 	} catch (Exception e) {
< 	    // Pam Wright, Imation Change InstantiationError to
< 	    // IllegalArgumentException InstantiationError did not
< 	    // get handled properly because it is not an exception
< 	    // IllegalArgument is a more appropriate class to
< 	    // characterize the problem.
< 	    throw new IllegalArgumentException(inStr+" is not a valid CIM date");
---
> 		return newString.toString();
222d186
<     }
224,235d187
<     
<     /**
<      * Determines if this instance represents an interval
<      * 
<      * @return TRUE if this is an interval
<      */
<     public boolean isInterval() {
<     	return(intervalSet);
<     }
<     
<     
<     
237,246c189,194
<     /**
<      * Returns a string representation of this date/time that is
<      * compliant with the CIM specification
<      *
<      * @return A string that represents a date/time
<      */
<     public String toString() {
< 	String sign;
< 	int offset=0;
< 	String outputString;
---
> 	/**
> 	 *	returns string representation of date
> 	 */
> 	public String toString(){
> 		return this.dateTime;
> 	}
248,249d195
<     	if (!intervalSet) {
< 	    int year=cal.get(Calendar.YEAR);
251,255d196
<             // Andrei Viktorov ProdEx Technologies
<             // was int month=cal.get(Calendar.MONTH);
<             // and return from 0 to 11 for jdk-1.2.2.
< 	    int month=cal.get(Calendar.MONTH)-cal.getMinimum(Calendar.MONTH)+1;
< 	    int day=cal.get(Calendar.DAY_OF_MONTH);
257,260c198,203
<             // Andrei Viktorov ProdEx Technologies
<             // was hours=cal.get(Calendar.HOUR),
<             // because HOUR is used for the 12-hour clock
< 	    hours=cal.get(Calendar.HOUR_OF_DAY);
---
> 	/**
> 	 *	Returns  string representation of date
> 	 */
> 	public String getDateTime() {
> 		return this.dateTime;
> 	}	
262,284c205,210
< 	    mins=cal.get(Calendar.MINUTE);
< 	    secs=cal.get(Calendar.SECOND);
< 	    milliseconds=cal.get(Calendar.MILLISECOND);
< 	    //int offsetHours=cal.get(Calendar.ZONE_OFFSET)/(60*60*1000);
< 	    int offsetHours=UTCoffset;
<             // Andrei Viktorov ProdEx Technologies
<             // was if (offsetHours<12)
< 	    if (offsetHours > 0) {
< 		offset= offsetHours; //cal.get(Calendar.ZONE_OFFSET)/(60*1000);
< 		sign="+";
< 	    } else {
<                 offset= -offsetHours; //- cal.get(Calendar.ZONE_OFFSET)/(60*1000);
< 		sign="-";
<     	    }
< 	    outputString=padString(year,4);
< 	    outputString=outputString.concat(padString(month,2));
< 	    outputString=outputString.concat(padString(day,2));
< 	} else {
< 	    outputString=padString(days,8);
< 	    // Pam Wright, Imation hours was duplicated in interval strings
< 	    // outputString=outputString.concat(padString(hours,2));
<             sign=":";
< 	}
---
> 	/**
> 	 *	Returns true if date is reprensented in time interval
> 	 */
> 	public boolean isInterval() {
> 		return this.isInterval;
> 	}	
286,292d211
< 	outputString=outputString.concat(padString(hours,2));
< 	outputString=outputString.concat(padString(mins,2));
< 	outputString=outputString.concat(padString(secs,2));
< 	outputString=outputString.concat(".");
< 	outputString=outputString.concat(padString(milliseconds,6));
< 	outputString=outputString.concat(sign);
< 	outputString=outputString.concat(padString(offset,3));
294,295c213,218
< 	return(outputString);
<     }
---
> 	/**
> 	 *	returns calendar representation of date
> 	 */
> 	public Calendar getCalendar(){
> 		return this.cal;
> 	}
298,306c221,237
<    /**
<     * Returns a string representation of this date/time that is
<     * compliant with the CIM specification
<     * 
<     * @return A string that represents a date/time
<     */
<     public String toMOF() {
< 	return(toString());
<     }
---
> 	/**
> 	 *	Determines if date/Interval is before 
> 	 */
> 	public boolean before(CIMDateTime date) {
> 		if( this.isInterval || date.isInterval()) {
> 			throw new IllegalArgumentException();
> 		}
> 		if(isInterval){
> 			if (this.dateTime.compareTo(date.getDateTime()) < 0 ) {
> 				return true;
> 			} else {
> 				return false;
> 			}	
> 		} else {	
> 			return ( cal.before(date.getCalendar()));
> 		}	
> 	}
307a239,245
> 	/**
> 	 *	Determines if date/Interval is  after
> 	 */
> 	public boolean after(CIMDateTime date) {
> 		if( this.isInterval || date.isInterval()) {
> 			throw new IllegalArgumentException();
> 		}
308a247,256
> 		if(isInterval){
> 			if (this.dateTime.compareTo(date.getDateTime()) > 0 ) {
> 				return true;
> 			} else {
> 				return false;
> 			}	
> 		} else {	
> 			return ( cal.after(date.getCalendar()));
> 		}
> 	}
310,341d257
<    /**
<     * Determines the date/time of this instance is after that of the
<     * instance passed
<     * 
<     * @param inDate The date to check against
<     * @return TRUE if this instance is after that of the instance passed
<     */
<     public boolean after(CIMDateTime inDate) {
<     	//
<     	// Return false if either CIMDataTime is an interval
<     	//
< 	if (intervalSet || inDate.intervalSet)
<     	    return(false);
< 	return(realCal.after(inDate.realCal));
<     }
<     
<     
<     /**
<      * Determines the date/time of this instance is before that of the
<      * instance passed
<      * 
<      * @param inDate The date to check against
<      * @return TRUE if this instance is before that of the instance passed
<      */
<     public boolean before(CIMDateTime inDate) {
<     	//
<     	// Return false if either CIMDataTime is an interval
<     	//		
< 	if (intervalSet || inDate.intervalSet)
<     		return(false);
< 	return(realCal.before(inDate.realCal));
<     }
343,368d258
<     
<     
<     /**
<      * Determines the date/time of this instance is equal to that of the
<      * instance passed
<      * 
<      * @param inDate The date to check against
<      * @return TRUE if this instance is equal to the instance passed
<      */	
<     public boolean equals(CIMDateTime inDate) {
< 	//
< 	// Look for intervals
< 	//
< 	if (intervalSet && inDate.intervalSet) {
< 	    return( days==inDate.days && hours==inDate.hours
< 		    && mins==inDate.mins && secs==inDate.secs 
< 		    && milliseconds==inDate.milliseconds);
<     	}
<     	//
<     	// Check both are not intervals (can't be equal in this case)
<     	//
< 	if (intervalSet || inDate.intervalSet)
< 	    return(false);
<     
<     	return(realCal.equals(inDate.realCal));
<     }
369a260,266
> 	/**
> 	 *	creates String  of specified length with leading zeros
> 	 *	from given integer
> 	 */
> 	private String padZero(int length, int value) {
> 		return padZero(length,String.valueOf(value));
> 	}
371,403c268,281
< 
<    /**
<     * Returns the calendar being used by this CIMDateTime
<     * 
<     * @return The current calendar in use
<     */
<     public Calendar getCalendar() {
< 	return((Calendar)realCal.clone());
<     }
<     
<    /**
<     * Produces a string from an integer of a specified length with
<     * leading zeros to pad
<     * 
<     * @param inVal The integer value to convert
<     * @param len The minium length of the String
<     * @return The padded string that represents the passed integer
<     */
<     private String padString(int inVal, int len) {
< 	String pad=new String("0");	
<     String buf=new Integer(inVal).toString();
<     	for(int i=buf.length();i<len;i++)
< 	    buf=pad.concat(buf);
<     	return(buf);	
<     }
< 	
<     static public void main(String[] args) {
< 	String in="19980525133015.000000-300";
< 	CIMDateTime date = new CIMDateTime(in);
< 		
< 	System.err.println("In was :"+in);
< 	System.err.println("Out was:"+date.toString());
< 	for(;;) {
---
> 	/**
> 	 *	creates String of specified length with leading zeros
> 	 *	from given string
> 	 */
> 	private String padZero(int length, String buf) {
> 		int delta = length - buf.length();
> 		if (delta < 1) {
> 			return buf;
> 		}
> 		String prefix = "0";
> 		for (int i = 1; i < delta; i++) {
> 			prefix = prefix + "0";
> 		}
> 		return prefix + buf;
405c283,293
<     }
---
> 
> 
> 	/**
> 	 *	Determines is dates are equal
> 	 */
> 	 public boolean equals(CIMDateTime date) {
> 		if( this.isInterval || date.isInterval()) {
> 			throw new IllegalArgumentException();
> 		}
> 		return dateTime.equals(date.getDateTime());
> 	 }
