1,530c1,413
< //
< // CIMOMHandleXML.java
< //
< // The contents of this file are subject to the SNIA Public License Version 1.0
< // (the "License"); you may not use this file except in compliance with the
< // License. You may obtain a copy of the License at
< //
< //      http://www.snia.org/resources/openSource.html
< //
< // Software distributed under the License is distributed on an "AS IS" basis,
< // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
< // License for the specific language governing rights and limitations
< // under the License.
< //
< // The Original Code is CIMOMHandleXML.java
< //
< // The Initial Developer of the Original Code is David Simons.
< //
< // Contributor(s):
< //
< //
< // This source uses the Solaris WBEM APIs dated June 1999. Synchronization
< // will be maintained with the Solaris WBEM APIS, which are being
< // standardized through the Java Community Process.
< //
< //
< // $Id$
< //
< // $Log$
< // Revision 1.13  2001/07/08 16:03:46  davidsi
< // - Removed DEFAULT_PORT
< //
< // Revision 1.12  2001/06/23 12:22:00  davidsi
< // - added support for running as a servlet within a webserver.
< //
< // Revision 1.11  2001/01/07 16:49:37  davidsi
< // - Now derived from CIMOMHandleSNIA so that no non-standard extensions
< //   are needed in CIMOMHandle which is defined by the WBEM JSR.
< //
< // Revision 1.10  2000/11/12 14:38:56  davidsi
< // - Constructor now reads which class to use as the http client from
< //   the config object.
< //
< // Revision 1.9  2000/11/06 18:43:33  davidsi
< // - Added support back for using simple built in webserver.
< //
< // Revision 1.8  2000/09/15 17:12:09  davidsi
< // - createInstance() now returns CIMObjectPath.
< //
< // Revision 1.7  2000/08/16 05:59:56  shawn
< // merge P_TOMCAT31 branch
< //
< // Revision 1.6.6.1  2000/08/10 00:03:32  shawn
< // head merge
< //
< // Revision 1.6  2000/07/10 17:31:09  davidsi
< // - Added call to HTTPOutput authenticate() function.
< //
< // Revision 1.5  2000/05/11 10:12:02  davidsi
< // - Fixed tabs.
< //
< // Revision 1.4  2000/05/06 17:15:33  davidsi
< // - Brought in line with SUN WBEM APIs 2.2
< //
< // Revision 1.3  2000/04/09 13:41:05  davidsi
< // - No longer assume root as a namespace - use the value on the passed
< //   path when enumerating.
< //
< // Revision 1.2  2000/02/13 15:09:46  davidsi
< // - Added text to cover re-use of Solaris WBEM APIs.
< //
< // Revision 1.1.1.1  2000/02/06 16:41:03  davidsi
< // Initial version.
< //
< //
< //
< package org.snia.wbemcmd.cimom;
< 
< 
< import java.util.*;
< import java.util.Enumeration;
< import java.util.Vector;
< import org.snia.wbem.cim.*;
< import org.snia.wbem.client.*;
< import org.snia.wbemcmd.utils.SimpleEnum;
< import org.snia.wbemcmd.utils.Log;
< import org.snia.wbemcmd.xml.*;
< import org.snia.wbemcmd.xml.XMLFeatures;
< 
< 
< //
< // This class provides XML access from a client
< //
< public class CIMOMHandleXML implements CIMOMHandleSNIA {
<     HTTPOutput output=null;
<     static Class classForOutput=null;
< 
<    /***
<     * @param ns  The name space that is to be referenced through this handle
<     */
<     public CIMOMHandleXML(CIMNameSpace ns) {
< 
<         //
<         // Locate class that handles the CIM client http functionality
<         //
<         if (classForOutput==null) {
<             String httpModule=org.snia.wbemcfg.GlobalConfig.httpClient;
<             try {
<                 classForOutput=Class.forName(httpModule);
<             } catch (Exception e) {
<                 Log.println("Failed to load class for http client:"+e);
<             }
<             if (classForOutput==null) {
<                 Log.println("Failed to load class:"+httpModule);
<                 throw new java.lang.InstantiationError("Failed to load class:"+httpModule);
<             }
<         }
< 
<         //
<         // Create instance for this handle
<         //
<         output=null;
<         try {
<             output=(HTTPOutput)classForOutput.newInstance();
<         } catch(InstantiationException ie) {
<             Log.println("failed to instantiate "+ie);
<         }  catch(IllegalAccessException ie) {
<             Log.println("failed to instantiate (IllegalAccessException) "+ie);
<         }
< 
<         if (output==null)
<             throw new java.lang.InstantiationError("Failed to create instance of "+org.snia.wbemcfg.GlobalConfig.httpClient);
<         output.setHostAndPort(ns.getHost(),ns.getHostURL().getPort());
<     }
< 
< 
<     public void authenticate(String userName,String password) throws CIMException{
<         output.authenticate(userName,password);
<     }
< 
< 
< 
<     //close
<     public void close() throws CIMException {
<         output.close();
<     }
< 
< 
<     //
<     // ns.getNameSpace() gives the new name space
<     //
<     public void createNameSpace(CIMNameSpace ns) throws CIMException{
<         String parentPath;
<         String nameSpace=ns.getNameSpace();
<         int index=nameSpace.lastIndexOf('/');
<         Vector keys=new Vector();
< 
<         if (index==-1)
<             throw new CIMException(CIMException.CIM_ERR_NOT_FOUND,
<                                     "A Namespace must only be created in an existing Namespace");
< 
< 
<         parentPath=nameSpace.substring(0,index);
< 
<         String newNameSpace=nameSpace.substring(nameSpace.lastIndexOf('/')+1);
< 
<         CIMObjectPath path=new CIMObjectPath(XMLNameSpace.NAMESPACECLASS,parentPath);
< 
<         CIMClass cimClass=getClass(path,false);
<         if (cimClass==null)
<             throw new CIMException(CIMException.CIM_ERR_NOT_FOUND,
<                                     "Could not find internal class "+XMLNameSpace.NAMESPACECLASS);
<         CIMInstance cimInstance=cimClass.newInstance();
<         CIMValue cv=new CIMValue(newNameSpace,CIMDataType.getPredefinedType(CIMDataType.STRING));
<         cimInstance.setProperty(XMLNameSpace.NAMEPROPERTY,cv);
< 
<         CIMObjectPath cimPath=new CIMObjectPath(XMLNameSpace.NAMESPACECLASS,
<                             cimInstance.getKeyValuePairs());
<         cimPath.setNameSpace(parentPath);
< 
<         createInstance(cimPath,cimInstance) ;
<     }
< 
< 
< 
<     //
<     // deleteNameSpace
<     //
<     public void deleteNameSpace(CIMNameSpace cns) throws CIMException{
<         String parentPath;
<         String nameSpace=cns.getNameSpace();
<         int index=nameSpace.lastIndexOf('/');
<         Vector keys=new Vector();
< 
<         if (index==-1)
<             throw new CIMException(CIMException.CIM_ERR_NOT_FOUND,
<                                     "A Namespace must only be created in an existing Namespace");
< 
<         parentPath=nameSpace.substring(0,index);
<         String newNameSpace=nameSpace.substring(nameSpace.lastIndexOf('/')+1);
< 
< 
<         Vector v=new Vector();
<         CIMValue cv=new CIMValue(newNameSpace,CIMDataType.getPredefinedType(CIMDataType.STRING));
<         CIMProperty cp=new CIMProperty();
<         cp.setName(XMLNameSpace.NAMEPROPERTY);
<         cp.setValue(cv);
<         cp.setType(CIMDataType.getPredefinedType(CIMDataType.STRING));
<         v.addElement(cp);
< 
<         CIMObjectPath path=new CIMObjectPath(XMLNameSpace.NAMESPACECLASS,v);
<         path.setNameSpace(parentPath);
<         deleteInstance(path);
<     }
< 
< 
<     private void enumNameSpaceULM(CIMObjectPath path,SimpleEnum enum,boolean deep)
<                                 throws CIMException{
<         Enumeration e=XMLEnumerateInstanceNames.enumInstances(output,path);
<         String name;
<         while(e.hasMoreElements()) {
<             CIMProperty nameProp=null;
< 
<             Object obj=e.nextElement();
<             if (obj instanceof CIMObjectPath) {
<                 Vector keys=((CIMObjectPath)obj).getKeys();
<                 if (keys.size()==1)
<                     nameProp=(CIMProperty)(keys.elementAt(0));
<                 else {
<                     for(int i=0;i<keys.size();i++) {
<                         CIMProperty cp=(CIMProperty)(keys.elementAt(i));
<                         if (cp.getName().equalsIgnoreCase("Name")) {
<                             nameProp=cp;
<                             break;
<                         }
<                     }
<                     throw new CIMException(CIMException.CIM_ERR_FAILED,
<                                             "Name of namespace not found");
<                 }
<                 enum.addElement( path.getNameSpace()+"/"+nameProp.getValue());
<                     if (deep==CIMClient.DEEP) {
<                         CIMObjectPath newObjPath=new CIMObjectPath(XMLNameSpace.NAMESPACECLASS,
<                                                     path.getNameSpace()+"/"+nameProp.getValue());
<                     enumNameSpaceULM(newObjPath,enum,deep);
<                 }
<             }
<         }
<     }
< 
<     // enumNameSpace
<     //
<     public Enumeration enumNameSpace(CIMObjectPath path,boolean deep) throws CIMException {
<         CIMObjectPath cop=new CIMObjectPath(XMLNameSpace.NAMESPACECLASS,path.getNameSpace());
<         SimpleEnum enum=new SimpleEnum();
<         enum.addElement(path.getNameSpace());
<         enumNameSpaceULM(cop,enum,deep);
<         return(enum);
<     }
< 
< 
< 
<     // deleteClass
<     //
<     public void deleteClass(CIMObjectPath path) throws CIMException{
<         XMLDeleteClass.deleteClass(output,path);
<     }
< 
< 
< 
<     // deleteInstance
<     //
<     public void deleteInstance(CIMObjectPath path) throws CIMException{
<         XMLDeleteInstance.deleteInstance(output,path);
<     }
< 
< 
< 
< 
<     // deleteQualifierType
<     //
<     public void deleteQualifierType(CIMObjectPath path) throws CIMException{
<         XMLDeleteQualifier.deleteQualifier(output,path);
<     }
< 
< 
< 
< 
< 
<     // enumClass
<     //
<     public Enumeration enumClass(CIMObjectPath path,
<                    boolean deep,
<                    boolean localOnly) throws CIMException {
<         return(XMLEnumerateClasses.enumClass(output,path,deep,localOnly));
< 
<     }
< 
< 
< 
<     // enumClass
<     //
<     public Enumeration enumClass(CIMObjectPath path,
<                    boolean deep) throws CIMException {
<         return(XMLEnumerateClassNames.enumClass(output,path,deep));
< 
<     }
< 
< 
< 
< 
<     // enumInstances
<     //
<     public Enumeration enumInstances(CIMObjectPath path,
<                        boolean deep) throws CIMException{
<         //
<         // SUNDIFF: Note that while the SUN API allows deep the
<         // XML encodings don't so we simply assume deep
<         //
<         return(XMLEnumerateInstanceNames.enumInstances(output,path));
< 
<     }
< 
< 
< 
<     // enumInstances
<     //
<     public Enumeration enumInstances(CIMObjectPath path,
<                        boolean deep,
<                        boolean localOnly) throws CIMException{
<         return(XMLEnumerateInstances.enumInstances(output,path,deep,localOnly));
< 
<     }
< 
< 
<     //enumQualifierTypes
<     //
<     public Enumeration enumQualifierTypes(CIMObjectPath path) throws CIMException{
<         return(XMLEnumerateQualifiers.enumQualifierTypes(output,path));
<     }
< 
< 
< 
< 
<     // getClass
<     public CIMClass getClass(CIMObjectPath path,
<                boolean localOnly) throws CIMException{
<         return(XMLGetClass.getClass(output,path,localOnly));
<     }
< 
< 
< 
<     // getInstance
<     //
<     public CIMInstance getInstance(CIMObjectPath path,
<                      boolean localOnly) throws CIMException {
<         return(XMLGetInstance.getInstance(output,path,localOnly));
< 
<     }
< 
< 
< 
< 
<     // invokeMethod
<     //
<     public CIMValue invokeMethod(CIMObjectPath path,
<                    String methodName,
<                    Vector inParams,
<                    Vector outParams) throws CIMException{
<             return(XMLMethodCall.methodCall(output,path,methodName,inParams,outParams));
<     }
< 
< 
< 
<     // getQualifierType
<     public CIMQualifierType getQualifierType(CIMObjectPath path)
<             throws CIMException{
<             return(XMLGetQualifier.getQualifier(output,path));
<     }
< 
< 
< 
<     // createQualifierType
<     public void createQualifierType(CIMObjectPath path,
<                       CIMQualifierType qt) throws CIMException{
<         XMLSetQualifier.setQualifier(output,path,qt);
<     }
< 
< 
< 
< 
<     // setQualifierType
<     //
<     public void setQualifierType(CIMObjectPath path,
<                    CIMQualifierType qt) throws CIMException{
<         XMLSetQualifier.setQualifier(output,path,qt);
<     }
< 
< 
<     // createClass
<     //
<     public void createClass(CIMObjectPath path,
<               CIMClass cc) throws CIMException {
<         XMLCreateClass.createClass(output,path,cc);
<     }
< 
< 
< 
<     // setClass
<     //
<    public void setClass(CIMObjectPath path,
<            CIMClass cc) throws CIMException {
<        XMLModifyClass.modifyClass(output,path,cc);
< 
<     }
< 
< 
< 
<     // createInstance
<     //
<     public CIMObjectPath createInstance(CIMObjectPath path,
<                  CIMInstance ci) throws CIMException{
<         return(XMLCreateInstance.createInstance(output,path,ci));
<     }
< 
< 
< 
<     // setInstance
<     //
<     public void setInstance(CIMObjectPath path,
<               CIMInstance ci) throws CIMException{
<         XMLModifyInstance.modifyInstance(output,path,ci);
<     }
< 
< 
< 
<     // getProperty
<     //
<     public CIMValue getProperty(CIMObjectPath path,
<                             String propertyName)throws CIMException{
<         return(XMLGetProperty.getProperty(output,path,propertyName));
<     }
< 
< 
<     // setProperty
<     //
<     public void setProperty(CIMObjectPath path,
<               String propertyName,
<               CIMValue newValue) throws CIMException{
<         XMLSetProperty.setProperty(output,path,propertyName,newValue);
<     }
< 
< 
< 
< 
< 
< 
<     //
<     // associatorNames
<     //
<     public Enumeration associatorNames(CIMObjectPath path,String assocClass,
<                                        String resultClass,
<                                   String role,String resultRole) throws CIMException{
<         return(XMLAssociatorNames.getNames(output,path,assocClass,resultClass,role,resultRole));
<     }
< 
<     //
<     // associators
<     //
<     public Enumeration associators(CIMObjectPath path,
<                                         String assocClass,
<                                         String resultClass,
<                                         String role,
<                                         String resultRole,
<                                         boolean includeQualifiers,
<                                         boolean includeClassOrigin,
<                                         String propertyList[])throws CIMException {
<         return(XMLAssociators.getNames(output,path, assocClass, resultClass, role,
<                                            resultRole, includeQualifiers, includeClassOrigin,propertyList));
<     }
< 
< 
<     //
<     // referenceNames
<     //
<     public Enumeration referenceNames(CIMObjectPath path,
<                                     String resultClass,
<                                     String role) throws CIMException {
<         return(XMLReferenceNames.getNames(output,path,resultClass,role));
<     }
< 
< 
<     //
<     // references
<     //
<     public Enumeration references(CIMObjectPath path,
<                                             String resultClass,
<                                             String role,
<                                             boolean includeQualifiers,
<                                             boolean includeClassOrigin,
<                                             String [] propertyList)throws CIMException {
<         return(XMLReferences.getNames(output,path,resultClass,role,includeQualifiers,includeClassOrigin,propertyList));
<     }
< 
<     public Enumeration execQuery(CIMObjectPath cop,
<                                           String query,int ql) throws CIMException {
<         return(XMLQuery.execQuery(output,cop,query,ql));
<     }
< 
<     public String encryptData(String data) throws CIMException {
<         return(data);   // SUNDIFF - no encryption
<     }
< 
<     //
<     // SUNDIFF START
<     //
< 
<     //
<     // getServerFeatures
<     //
<     public CIMFeatures getServerFeatures() throws CIMException
<     {
<         XMLFeatures features=new XMLFeatures();
<         features.getFeatures(output);
<         return(features);
<     }
< 
<     //
<     // SUNDIFF END
<     //
< }
---
> /*
> static char sccsid[] = "@(#)60  1.2  src/com/ibm/xml/CIMOMHandleXML.java, cimom, ICAT1, ICAT1_1.1.0.0 12/5/02 18:15:23";
> */
> 
> //
> // CIMOMHandleXML.java
> //
> // The contents of this file are subject to the SNIA Public License Version 1.0
> // (the "License"); you may not use this file except in compliance with the
> // License. You may obtain a copy of the License at
> //
> //      http://www.snia.org/resources/openSource.html
> //
> // Software distributed under the License is distributed on an "AS IS" basis,
> // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
> // License for the specific language governing rights and limitations
> // under the License.
> //
> // The Original Code is CIMOMHandleXML.java
> //
> // The Initial Developer of the Original Code is David Simons.
> //
> // Contributor(s):
> //
> //
> // This source uses the Solaris WBEM APIs dated June 1999. Synchronization
> // will be maintained with the Solaris WBEM APIS, which are being
> // standardized through the Java Community Process.
> //
> //
> // $Id$
> //
> // $Log$
> // Revision 1.13  2001/07/08 16:03:46  davidsi
> // - Removed DEFAULT_PORT
> //
> // Revision 1.12  2001/06/23 12:22:00  davidsi
> // - added support for running as a servlet within a webserver.
> //
> // Revision 1.11  2001/01/07 16:49:37  davidsi
> // - Now derived from CIMOMHandleSNIA so that no non-standard extensions
> //   are needed in CIMOMHandle which is defined by the WBEM JSR.
> //
> // Revision 1.10  2000/11/12 14:38:56  davidsi
> // - Constructor now reads which class to use as the http client from
> //   the config object.
> //
> // Revision 1.9  2000/11/06 18:43:33  davidsi
> // - Added support back for using simple built in webserver.
> //
> // Revision 1.8  2000/09/15 17:12:09  davidsi
> // - createInstance() now returns CIMObjectPath.
> //
> // Revision 1.7  2000/08/16 05:59:56  shawn
> // merge P_TOMCAT31 branch
> //
> // Revision 1.6.6.1  2000/08/10 00:03:32  shawn
> // head merge
> //
> // Revision 1.6  2000/07/10 17:31:09  davidsi
> // - Added call to HTTPOutput authenticate() function.
> //
> // Revision 1.5  2000/05/11 10:12:02  davidsi
> // - Fixed tabs.
> //
> // Revision 1.4  2000/05/06 17:15:33  davidsi
> // - Brought in line with SUN WBEM APIs 2.2
> //
> // Revision 1.3  2000/04/09 13:41:05  davidsi
> // - No longer assume root as a namespace - use the value on the passed
> //   path when enumerating.
> //
> // Revision 1.2  2000/02/13 15:09:46  davidsi
> // - Added text to cover re-use of Solaris WBEM APIs.
> //
> // Revision 1.1.1.1  2000/02/06 16:41:03  davidsi
> // Initial version.
> //
> //
> //
> package com.ibm.xml;
> 
> import java.util.*;
> import java.util.Enumeration;
> import java.util.Vector;
> import java.io.*;
> import com.ibm.cim.*;
> import com.ibm.cimom.util.*;
> import com.ibm.xml.*;
> import com.ibm.http.*;
> 
> //
> // This class provides XML access from a client
> //
> public class CIMOMHandleXML {
> 	public HTTPClient output = null;
> 	public HTTPIndServer indServer = null;
> 	public CIMListenerMgr lmgr = null;
> 	public boolean indications = false;
> 
>    /***
>     * @param ns  The name space that is to be referenced through this handle
>     */
>     public CIMOMHandleXML(CIMNameSpace ns, String userName, String password) throws CIMException {
> 		String langTags = ns.getLanguage();
> 		boolean digest = ns.getAuthentication();
> 		boolean http11 = ns.isHttp11();
> 		boolean isSSL = ns.isSSL();
> 		indications = ns.getIndications();
> 
> 		output = new HTTPClient(langTags, digest, http11, ns.getHost(), ns.getPort(), isSSL, ns.getTrustStore(), ns.getTrustPassword());
> 		output.setCredentials(userName, password);
> 		if (ns.getCloseConnections() == true) {
> 			output.singleRequestsOnly();
> 		}
> 
> 		if (indications == true) {
> 			lmgr = new CIMListenerMgr();
> 			indServer = new HTTPIndServer(output, lmgr, ns.getIndPort(), isSSL);
> 			indServer.setDaemon(true);
> 			indServer.start();
> 		}
>     }
> 
>     public CIMOMHandleXML() {
> 		output = new HTTPClient();
>     }
> 
>     //close
>     public void close() throws Exception {
>        	output.close();
> 		if (indications == true) {
> 			indServer.interrupt();
> 			indServer.join(25000);
> 		}
>     }
> 
> 
>     //
>     // ns.getNameSpace() gives the new name space
>     //
>     public void createNameSpace(CIMNameSpace ns) throws CIMException{
>         throw new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED);
>     }
> 
> 
> 
>     //
>     // deleteNameSpace
>     //
>     public void deleteNameSpace(CIMNameSpace cns) throws CIMException{
>         throw new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED);
>     }
> 
> 
> 
>     // enumNameSpace
>     //
>     public Enumeration enumNameSpace(CIMObjectPath path,boolean deep) throws CIMException {
>         CIMObjectPath cop=new CIMObjectPath(XMLNameSpace.NAMESPACECLASS,path.getNameSpace());
>         SimpleEnum enum=new SimpleEnum();
> 
> 	  Enumeration e=XMLEnumerateInstanceNames.enumInstances(output, cop);
> 	  CIMProperty cp=null;
>         String name;
> 
>         while(e.hasMoreElements()) {
> 		cop = (CIMObjectPath)e.nextElement();
>             Vector keys=cop.getKeys();
> 
>             for(int i=0; i< keys.size();i++) {
> 	            cp=(CIMProperty)(keys.elementAt(i));
>                   if (cp.getName().equalsIgnoreCase("Name")) {
> 				break;
>                   }
> 			cp = null;
>           	}
> 
> 		if (cp != null) {
> 			CIMValue cv = cp.getValue();
> 			String ns = (String)cv.getValue();
> 			ns.replace('/', File.separatorChar);
> 		      ns.replace('\\', File.separatorChar);
> 
> 			enum.addElement(ns);
> 		} else {
>                   throw new CIMException(CIMException.CIM_ERR_FAILED, "Name of namespace not found");
> 		}
> 	  }
> 
> 	  return enum;
>     }
> 
> 
>     // deleteClass
>     //
>     public void deleteClass(CIMObjectPath path) throws CIMException{
>         XMLDeleteClass.deleteClass(output,path);
>     }
> 
> 
> 
>     // deleteInstance
>     //
>     public void deleteInstance(CIMObjectPath path) throws CIMException{
>         XMLDeleteInstance.deleteInstance(output,path);
>     }
> 
> 
> 
> 
>     // deleteQualifierType
>     //
>     public void deleteQualifierType(CIMObjectPath path) throws CIMException{
>         XMLDeleteQualifier.deleteQualifier(output,path);
>     }
> 
> 
> 
> 
> 
>     // enumClass
>     //
>     public Enumeration enumClass(CIMObjectPath path,
>                    boolean deep,
>                    boolean localOnly) throws CIMException {
>         return(XMLEnumerateClasses.enumClass(output,path,deep,localOnly));
>     }
> 
> 
> 
>     // enumClass
>     //
>     public Enumeration enumClass(CIMObjectPath path,
>                    boolean deep) throws CIMException {
>         return(XMLEnumerateClassNames.enumClass(output,path,deep));
>     }
> 
> 
>     // enumInstances
>     //
>     public Enumeration enumInstances(CIMObjectPath path,
>                        boolean deep) throws CIMException{
>         return(XMLEnumerateInstanceNames.enumInstances(output,path));
>     }
> 
> 
> 
>     // enumInstances
>     //
>     public Enumeration enumInstances(CIMObjectPath path,
>                        boolean deep,
>                        boolean localOnly) throws CIMException{
>         return(XMLEnumerateInstances.enumInstances(output,path,deep,localOnly));
>     }
> 
> 
>     //enumQualifierTypes
>     //
>     public Enumeration enumQualifierTypes(CIMObjectPath path) throws CIMException{
>         return(XMLEnumerateQualifiers.enumQualifierTypes(output,path));
>     }
> 
> 
> 
> 
>     // getClass
>     public CIMClass getClass(CIMObjectPath path,
>                boolean localOnly) throws CIMException{
>         return(XMLGetClass.getClass(output,path,localOnly));
>     }
> 
> 
>     // getInstance
>     //
>     public CIMInstance getInstance(CIMObjectPath path,
>                      boolean localOnly) throws CIMException {
> 	return(XMLGetInstance.getInstance(output,path,localOnly));
>     }
> 
> 
>     // invokeMethod
>     //
>     public CIMValue invokeMethod(CIMObjectPath path,
>                    String methodName,
>                    Vector inParams,
>                    Vector outParams) throws CIMException{
>     		return(XMLMethodCall.methodCall(output,path,methodName,inParams,outParams));
>     }
> 
>     // getQualifierType
>     public CIMQualifierType getQualifierType(CIMObjectPath path)
>             throws CIMException{
>             return(XMLGetQualifier.getQualifier(output,path));
>     }
> 
>     // createQualifierType
>     public void createQualifierType(CIMObjectPath path,
>                       CIMQualifierType qt) throws CIMException{
>         XMLSetQualifier.setQualifier(output,path,qt);
>     }
> 
> 
>     // setQualifierType
>     //
>     public void setQualifierType(CIMObjectPath path,
>                    CIMQualifierType qt) throws CIMException{
>         XMLSetQualifier.setQualifier(output,path,qt);
>     }
> 
> 
>     // createClass
>     //
>     public void createClass(CIMObjectPath path,
>               CIMClass cc) throws CIMException {
>         XMLCreateClass.createClass(output,path,cc);
>     }
> 
> 
> 
>     // setClass
>     //
>    public void setClass(CIMObjectPath path,
>            CIMClass cc) throws CIMException {
>        XMLModifyClass.modifyClass(output,path,cc);
>     }
> 
> 
>     // createInstance
>     //
>     public CIMObjectPath createInstance(CIMObjectPath path,
>                  CIMInstance ci) throws CIMException{
>         return(XMLCreateInstance.createInstance(output,path,ci));
>     }
> 
> 
>     // setInstance
>     //
>     public void setInstance(CIMObjectPath path,
>               CIMInstance ci) throws CIMException{
>         XMLModifyInstance.modifyInstance(output,path,ci);
>     }
> 
> 
>     // getProperty
>     //
>     public CIMValue getProperty(CIMObjectPath path,
>                             String propertyName)throws CIMException{
>         return(XMLGetProperty.getProperty(output,path,propertyName));
>     }
> 
> 
>     // setProperty
>     //
>     public void setProperty(CIMObjectPath path,
>               String propertyName,
>               CIMValue newValue) throws CIMException{
>         XMLSetProperty.setProperty(output,path,propertyName,newValue);
>     }
> 
>     //
>     // associatorNames
>     //
>     public Enumeration associatorNames(CIMObjectPath path,String assocClass,
>                                        String resultClass,
>                                   String role,String resultRole) throws CIMException{
>        return(XMLAssociatorNames.getNames(output,path,assocClass,resultClass,role,resultRole));
>     }
> 
>     //
>     // associators
>     //
>     public Enumeration associators(CIMObjectPath path,
>                                         String assocClass,
>                                         String resultClass,
>                                         String role,
>                                         String resultRole,
>                                         boolean includeQualifiers,
>                                         boolean includeClassOrigin,
>                                         String propertyList[])throws CIMException {
>         return(XMLAssociators.getNames(output,path, assocClass, resultClass, role,
>                                            resultRole, includeQualifiers, includeClassOrigin,propertyList));
>     }
> 
> 
>     //
>     // referenceNames
>     //
>     public Enumeration referenceNames(CIMObjectPath path,
>                                     String resultClass,
>                                     String role) throws CIMException {
>         return(XMLReferenceNames.getNames(output,path,resultClass,role));
>     }
> 
> 
>     //
>     // references
>     //
>     public Enumeration references(CIMObjectPath path,
>                                             String resultClass,
>                                             String role,
>                                             boolean includeQualifiers,
>                                             boolean includeClassOrigin,
>                                             String [] propertyList)throws CIMException {
>         return(XMLReferences.getNames(output,path,resultClass,role,includeQualifiers,includeClassOrigin,propertyList));
>     }
> 
>     public Enumeration execQuery(CIMObjectPath cop,
>                                           String query,int ql) throws CIMException {
>     	return(XMLExecQuery.execQuery(output,cop,query,ql));
>     }
> 
> }
