1,670c1,608
< //
< // CIMProperty.java
< //
< // The contents of this file are subject to the SNIA Public License Version 1.0
< // (the "License"); you may not use this file except in compliance with the
< // License. You may obtain a copy of the License at
< //
< //      http://www.snia.org/resources/openSource.html
< //
< // Software distributed under the License is distributed on an "AS IS" basis,
< // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
< // License for the specific language governing rights and limitations
< // under the License.
< //
< // The Original Code is CIMProperty.java
< //
< // The Initial Developer of the Original Code is David Simons.
< //
< // Contributor(s):
< //
< //
< // This source uses the Solaris WBEM APIs version 2.2.
< // Synchronization will be maintained with the Solaris WBEM APIS,
< // which are being standardized through the Java Community Process.
< //
< //
< // $Id$
< //
< // $Log$
< // Revision 1.13  2001/04/15 23:59:33  davidsi
< // - Fixed <VALUE.ARRAY> generation for xml output.
< //
< // Revision 1.12  2000/11/09 17:36:05  davidsi
< // - Handle null datatypes for properties.
< //
< // Revision 1.11  2000/11/07 20:07:43  davidsi
< // - Preinitialize qualifiers to be an empty vector.
< //
< // Revision 1.10  2000/11/06 18:12:03  davidsi
< // - Added support for using java objects rather than strings to store
< //   CIM values.
< //
< // Revision 1.9  2000/08/16 05:59:52  shawn
< // merge P_TOMCAT31 branch
< //
< // Revision 1.8.6.1  2000/08/10 00:03:27  shawn
< // head merge
< //
< // Revision 1.8  2000/07/19 16:49:56  davidsi
< // - setQualifiers now throws an Error if the passed vector contains an
< //   object which is not a qualifier.
< //
< // Revision 1.7  2000/07/10 17:04:38  davidsi
< // - Fixed constructor to set property data type.
< //
< // Revision 1.6  2000/05/11 10:12:20  davidsi
< // - Fixed tabs.
< //
< // Revision 1.5  2000/05/07 13:30:52  davidsi
< // - Modified originClass so that an empty string is used when there is no
< //   origin class rather than a null value.
< //
< // Revision 1.4  2000/05/06 17:04:22  davidsi
< // - Modifications to bring classes inline with the SUN WBEM APIs 2.2.
< //
< // Revision 1.3  2000/04/09 13:19:15  davidsi
< // - Switched to StringBuffer (from String) for XML generation.
< //
< // Revision 1.2  2000/02/13 15:09:07  davidsi
< // - Added text to cover re-use of Solaris WBEM APIs.
< //
< // Revision 1.1.1.1  2000/02/06 16:41:03  davidsi
< // Initial version.
< //
< //
< //
< package org.snia.wbem.cim;
< 
< import java.net.MalformedURLException;
< import java.util.Vector;
< import java.io.Serializable;
< import java.io.StringReader;
< import java.util.Date;
< import java.lang.reflect.Array;
< import org.snia.wbemcmd.xml.*;
< import java.util.GregorianCalendar;
< import java.util.Calendar;
< import org.snia.wbem.cim.CIMDateTime;
< import org.snia.wbemcmd.cimom.CIMOMCast;
< 
< 
< public class CIMProperty  extends CIMElement implements Cloneable, Serializable {
<     static private String noOriginClass="";
<     //
<     // If you add to these, you need to fix the clone() method!
<     //
<     Vector qualifiers=new Vector();
<     //
<     // Note that we can't rely on the cimValue's datatype
<     // because that is determined by what gets stored  as
<     // a value rather than what the MOF declared which is
<     // what is stored in propertyDataType.
<     //
<     CIMDataType propertyDataType=null;
<     //
<     // For an array type property this states how large it
<     // was declared as
<     //
<     int sizeDataType= -1;
<     String override=null;
<     String originClass=noOriginClass;
<     CIMValue cimValue=null;
<     boolean propagated=false;       // propagated means inherited without change
< 
<     // CIMProperty
<     //
<     public CIMProperty() {
<     }
< 
<     // CIMProperty name
<     //
<     // Creates a property with a name
<     //
<     public CIMProperty(String name) {
<         setName(name);
<     }
< 
<     // CIMProperty
<     //
<     // Creates a property with a name and value
<     //
<     public CIMProperty(String name,CIMValue val) {
<         setName(name);
<         cimValue=val;
<         propertyDataType=val.getType();
<     }
< 
<     //
<     // CIMProperty
<     //
<     // Create a property using a XML definition
<     //
<     // @param node The node containing an XML definition of CIMProperty
<     //
<     public CIMProperty(org.w3c.dom.Node node) {
<         XMLNode qnode=XMLNode.getXMLNode(node);
<         String superClassName;
<         String inClassName;
< 
<         int token=qnode.getToken();
<         if (token!=XMLNode.XML_ELEMENT_PROPERTY &&
<             token!=XMLNode.XML_ELEMENT_PROPERTY_ARRAY &&
<             token!=XMLNode.XML_ELEMENT_PROPERTY_REF )
<                 throw new java.lang.InstantiationError("Not a property node");
<         try {
<             String propName=qnode.getAttribute(XMLParameters.paramName);
<             String cimType=qnode.getAttribute(XMLParameters.paramTypeAssign);
<             String classOrigin=qnode.getAttribute(XMLParameters.paramClassOrigin);
<             String propagate=qnode.getAttribute(XMLParameters.paramPropagated);
< 
<             if (propName==null)
<                 throw new CIMException(CIMException.CIM_ERR_INVALID_PARAMETER,
<                     "No property name");
<             //
<             // If no return data type, then property isn't properly defined
<             //
<             if (token==XMLNode.XML_ELEMENT_PROPERTY_REF) {
<                 String refClass=qnode.getAttribute(XMLParameters.paramReferenceClass);
<                 propertyDataType=new CIMDataType(refClass);
<             } else  if (cimType!=null)
<                 propertyDataType=CIMDataType.getDataType(cimType);
<             //
<             // Array type property
<             //
<             if (token==XMLNode.XML_ELEMENT_PROPERTY_ARRAY) {
<                 String arraySize=qnode.getAttribute(XMLParameters.paramArraySize);
<                 if (arraySize!=null) {
<                     propertyDataType=new CIMDataType(CIMDataType.findArrayType(
<                             propertyDataType.getType()),new Integer(arraySize).intValue());
<                 } else {
<                     propertyDataType=new CIMDataType(CIMDataType.findArrayType(propertyDataType.getType()));
<                 }
<             }
< 
<             if (propertyDataType==null) {
<                 new CIMException(CIMException.CIM_ERR_FAILED,"Property was null datatype "+propName);
<             }
< 
<             setName(propName);
<             if (classOrigin!=null)
<                 setOriginClass(classOrigin);
<             if (propagate!=null && propagate.equalsIgnoreCase("true"))
<                 setPropagated(true);
<             else
<                 setPropagated(false);
< 
<             //
<             // See if there are qualifiers
<             //
<             boolean embedded=false;
<             for(qnode=qnode.getChild();qnode!=null && qnode.getToken()==XMLNode.XML_ELEMENT_QUALIFIER;
<                     qnode=qnode.getNext()){
<                 CIMQualifier qual=new CIMQualifier(qnode);
<                 if (qual.getName().equalsIgnoreCase("embeddedobject")) {
<                    embedded=true;
<                 }
<                 qualifiers.addElement(qual);
<             }
<             if (qnode!=null) {
<                CIMValue propValue=new CIMValue(qnode);
<                if (embedded) {
<                   XMLParse embXml=null;
<                   XMLNode embNode=null;
<                   String xml=propValue.toString();
<             //      System.err.println("embedded string: "+xml);
<                   if (xml.startsWith("<![CDATA["))
<                      xml=xml.substring(9,xml.length()-3);
<                   embXml=new XMLParse(new StringReader(xml));
<                   embNode=embXml.parse();
<                   if (xml.startsWith("<I")) {
<                      cimValue=new CIMValue(new CIMInstance(embNode),
<                         CIMDataType.getPredefinedType(CIMDataType.OBJECT));
<                   }
<                   else if (xml.startsWith("<C")) {
<                      cimValue=new CIMValue(new CIMClass(embNode),
<                         CIMDataType.getPredefinedType(CIMDataType.CLASS));
<                   }
<                }
<                else cimValue=CIMOMCast.castDataType(propValue,propertyDataType);
<             }
<         } catch (CIMException ce) {
<             ce.printStackTrace();
<             throw new java.lang.InstantiationError(ce.toString());
<         }
<     }
< 
< 
<     //
<     // getQualifiers
<     //
<     // Returns the qualifiers
<     //
<     public Vector getQualifiers() {
<         return(qualifiers);
<     }
< 
<     // setQualifiers
<     //
<     // Sets qualifiers
<     public void setQualifiers(Vector q){
<         int i;
<         int tsize=q.size();
<         for(i=0;i<tsize;i++) {
<             Object nq=q.elementAt(i);
<             if (!(nq instanceof CIMQualifier))
<                 throw new Error(nq.toString()+" is not a qualifier");
<         }
<         qualifiers=q;
<     }
< 
<     // getOriginClass
<     //
<     // Returns class that defined the property
<     //
<     public String getOriginClass() {
<         return(originClass);
<     }
< 
<     // setOriginClass
<     //
<     // Sets the defining class
<     //
<     public void setOriginClass(String ioriginClass) {
<         originClass=ioriginClass;
<     }
< 
< 
<     // setValue
<     //
<     // Sets the value
<     //
<     public void setValue(CIMValue aValue){
<         try {
<             //
<             // If the property has been given a type then cast to that type
<             // otherwise assume the type is the same as the passed value
<             //
<             if (propertyDataType!=null)
<                 cimValue=CIMOMCast.castDataType(aValue,propertyDataType);
<             else {
<                 cimValue=aValue;
<                 if (propertyDataType==null)
<                     propertyDataType=aValue.getType();
<             }
<         } catch (CIMException ce) {
<             cimValue=null; // TODO, really would like to propagate the error
<         }
<     }
< 
< 
<     // getValue
<     //
<     // Gets the value
<     //
<     public CIMValue getValue() {
<         return(cimValue);
<     }
< 
<     // setType
<     //
<     // Sets the data type
<     //
<     public void setType(CIMDataType aType){
<         propertyDataType=aType;
<     }
< 
<     // getType
<     //
<     // Gets the data type
<     //
<     public CIMDataType getType(){
<         return(propertyDataType);
<     }
< 
<     // getSize
<     //
<     // Returns the size
<     //
<     public int getSize(){
<         return(sizeDataType);
<     }
< 
<     // setSize
<     //
<     // Sets the size
<     //
<     public void setSize(int isize) {
<         sizeDataType=isize;
<     }
< 
< 
<     // setOverridingProperty
<     //
<     public void setOverridingProperty(String op){
<         override=op;
<     }
< 
<     // getOverridingProperty
<     //
<     // Gets the overriding property name
<     //
<     public String getOverridingProperty() {
<         return(override);
<     }
< 
< 
<     // isReference
<     //
<     // Returns TRUE if this property is a CIM reference
<     //
<     public boolean isReference(){
<         return(propertyDataType.isReferenceType());
<     }
< 
< 
<     // getQualifier
<     //
<     // Returns the specified CIM qualifier
<     public CIMQualifier getQualifier(String name) {
<         int i;
<         int tsize=qualifiers.size();
<         for(i=0;i<tsize;i++) {
<             CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
<             if (nq.getName().equalsIgnoreCase(name)) {
<                 return((CIMQualifier)(qualifiers.elementAt(i)));
<             }
<         }
<         return(null);
<     }
< 
<     // setQualifier
<     //
<     // Sets a qualifier
<     //
<     public CIMQualifier setQualifier(CIMQualifier cq) throws CIMException {
<         int i;
< 
<         int tsize=qualifiers.size();
<         for(i=0;i<tsize;i++) {
<             CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
<             if (nq.getName().equalsIgnoreCase(cq.getName())) {
<                 qualifiers.setElementAt(cq,i);
<                 return(cq);
<             }
<         }
<         throw new CIMException(CIMException.CIM_ERR_NOT_FOUND,
<             "Qualifier "+cq.getName()+" not found");
<     }
< 
<     // addQualifier
<     //
<     // Adds a qualifier
<     //
<     public void addQualifier(CIMQualifier cq) throws CIMException {
<         int i;
< 
<         int tsize=qualifiers.size();
<         for(i=0;i<tsize;i++) {
<             CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
<             if (nq.getName().equalsIgnoreCase(cq.getName())) {
<                 throw new CIMException(CIMException.CIM_ERR_ALREADY_EXISTS,
<                         "Qualifier "+cq.getName()+" already exists");
<             }
<         }
<         qualifiers.addElement(cq);
<     }
< 
<     // removeQualifier
<     //
<     // Removes a qualifier
<     //
<     public boolean removeQualifier(String name) {
<         int i;
< 
<         int tsize=qualifiers.size();
<         for(i=0;i<tsize;i++) {
<             CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
<             if (nq.getName().equalsIgnoreCase(name)) {
<                 qualifiers.removeElementAt(i);
<                 return(true);
<             }
<         }
<         return(false);
<     }
< 
<     // toString
<     public String toString() {
< 
<         if (cimValue!=null && cimValue.getValue()!=null)
<             return(propertyDataType.toString()+":"+getName()+"="+cimValue.getValue());
<         else
<             return(propertyDataType.toString()+":"+getName()+"=null");
<     }
< 
<     //toMOF
<     public String toMOF() {
<         String ret;
<         int i;
< 
<         ret=new String();
<         if (qualifiers!=null && qualifiers.size()>0) {
<             ret=ret.concat("[");
<             for(i=0;i<qualifiers.size();i++) {
<                 CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
<                 if (i>0)
<                     ret=ret.concat(",");
<                 ret=ret.concat(nq.toMOF());
<             }
<             ret=ret.concat("]");
<         }
< 
< 
<         ret=ret.concat(propertyDataType.toMOF());
<         ret=ret.concat(" ");
<         ret=ret.concat(getName());
<         if (cimValue!=null) {
<             ret=ret.concat("=");
<             ret=ret.concat(cimValue.toMOF());
<         }
<         ret=ret.concat(";\n");
<         return(ret);
<     }
< 
<     // clone
<     //
<     public Object clone(){
<        return(clone(true,true));
<     }
< 
<     public Object clone(boolean includeQualifier,
<                                   boolean includeClassOrigin) {
<         CIMProperty cp=new CIMProperty();
< 
<         //
<         // Only things that can get changed on a per instance
<         // basis get fully dup'd, the rest is just by reference
<         //
<         if (includeQualifier && qualifiers!=null) {
<             cp.qualifiers=new Vector();
<             int tsize=qualifiers.size();
<             for(int i=0;i<tsize;i++) {
<                 CIMQualifier cq=(CIMQualifier)(qualifiers.elementAt(i));
<                 cp.qualifiers.addElement(cq.clone());
<             }
<         }
<         cp.propertyDataType=propertyDataType;
<         cp.sizeDataType=sizeDataType;
< 
<         cp.setName(getName());
<         if (cp.override!=null)
<             cp.override=override;
<         if (cp.originClass!=null)
<             cp.originClass=originClass;
<         if (cimValue!=null)
<             cp.cimValue=new CIMValue(cimValue.getValue(),cimValue.getType());
< 
<         cp.propagated=propagated;
<         return(cp);
<     }
<     // isKey
<     //
<     // Returns TRUE if property is a KEY
<     public boolean isKey() {
<         int tsize=qualifiers.size();
<         for(int j=0;j<tsize;j++) {
<             CIMQualifier cq=(CIMQualifier)(qualifiers.elementAt(j));
<             if (cq.getName().equalsIgnoreCase(CIMQualifier.CIM_QUAL_KEY))
<                 return(true);
<         }
<         return(false);
<     }
< 
<     public String toXml() throws MalformedURLException {
<         return(toXml(false,true,true));
<     }
< 
<     //
<     // NOT SUN
<     //
< 
<     // toXml
<     public String toXml(boolean localOnly,
<                         boolean includeQualifiers,
<                         boolean includeClassOrigin) throws MalformedURLException{
<         StringBuffer text=new StringBuffer();
<         boolean isArray=false;
<         boolean isRef=false;
<         String cimName=getName();
< 
<         if (cimName==null)
<             throw new MalformedURLException("property must have name");
< 
<         //
<         // If only local definitions are required and this is a propagated
<         // property then nothing to return
<         //
<         if (localOnly && propagated)
<             return("");
< 
<         //
<         if (propertyDataType!=null) {
<             isArray=propertyDataType.isArrayType();
<             isRef=propertyDataType.isReferenceType();
< 
<             if (isArray) {
<                 text=text.append("<PROPERTY.ARRAY NAME=\""+cimName+"\" "+
<                                  "TYPE=\""+
<                                 CIMDataType.getPredefinedType(
<                                             CIMDataType.findSimpleType(
<                                             propertyDataType.getType())).toXml()+"\" ");
<                 int size=propertyDataType.getSize();
<                 if (size!=-1)   // i.e not unlimited
<                     text=text.append("ARRAYSIZE=\""+size+"\" ");
<             } else if (isRef) {
<                 text=text.append("<PROPERTY.REFERENCE NAME=\""+cimName+"\" "+
<                                  "REFERENCECLASS=\""+propertyDataType.getRefClassName()+"\" ");
<             } else
<                 text=text.append("<PROPERTY NAME=\""+cimName+"\" "+
<                                  "TYPE=\""+propertyDataType.toXml()+"\" ");
<         } else {
<             throw new MalformedURLException("Property "+cimName+" has no type defined");
<         }
< 
<         if (includeClassOrigin && originClass!=null)
<             text=text.append("CLASSORIGIN=\""+originClass+"\" ");
<         if (propagated==true)
<             text=text.append("PROPAGATED=\"true\" ");
< 
<         text=text.append(">");
< 
<         if (qualifiers!=null && includeQualifiers) {
<             for(int i=0;i<qualifiers.size();i++) {
<                 CIMQualifier cq=(CIMQualifier)(qualifiers.elementAt(i));
<                 text=text.append(cq.toXml());
<             }
<         }
< 
<         if (cimValue!=null) {
<             if (cimValue.getType().getType()==CIMDataType.OBJECT) {
<                Object o=cimValue.getValue();
<                String xml=null;
<                if (o instanceof CIMInstance) {
<                   CIMInstance ei=(CIMInstance)cimValue.getValue();
<                   xml="<![CDATA["+ei.toXml()+"]]>";
<                //   System.err.println("--- xml: "+xml);
<                   CIMValue nv=new CIMValue(xml);
<                   text=text.append(nv.toXml());
<                }
<                else System.err.println("--- ??? 1");
<             }
<             else if (cimValue.getType().getType()==CIMDataType.CLASS) {
<                Object o=cimValue.getValue();
<                String xml=null;
<                if (o instanceof CIMClass) {
<                   CIMClass ec=(CIMClass)cimValue.getValue();
<                   xml="<![CDATA["+ec.toXml(true)+"]]>";
<                //   System.err.println("--- xml: "+xml);
<                   CIMValue nv=new CIMValue(xml);
<                   text=text.append(nv.toXml());
<                }
<                else System.err.println("--- ??? 2");
<             }
<             else text=text.append(cimValue.toXml());
<         }
< 
<         if (isArray)
<             text=text.append("</PROPERTY.ARRAY>");
<         else if (isRef)
<             text=text.append("</PROPERTY.REFERENCE>");
<         else
<             text=text.append("</PROPERTY>");
< 
<         return(text.toString());
< 
<     }
< 
<     //
<     // Returns a filtered version of the property
<     //
<     public CIMProperty filter(boolean localOnly,
<                     boolean includeQualifiers)  {
<         //
<         // If only local definitions are required and this is a propagated
<         // property then nothing to return
<         //
<         if (localOnly && propagated)
<             return(null);
< 
<         CIMProperty cp=new CIMProperty();
<         cp.propertyDataType=propertyDataType;
<         cp.sizeDataType=sizeDataType;
<         cp.setName(getName());
<         if (cp.override!=null)
<             cp.override=override;
<         if (cp.originClass!=null)
<             cp.originClass=originClass;
<         if (cimValue!=null)
<             cp.cimValue=new CIMValue(cimValue.getValue(),cimValue.getType());
<         cp.propagated=propagated;
< 
<         //
<         if (qualifiers!=null && includeQualifiers) {
<             cp.qualifiers=new Vector();
<             for(int i=0;i<qualifiers.size();i++) {
<                 CIMQualifier cq=(CIMQualifier)(qualifiers.elementAt(i));
<                 cp.qualifiers.addElement(cq.clone());
<             }
<         }
<         return(cp);
<     }
< 
< 
<     public void setPropagated(boolean value) {
<         propagated=value;
<     }
< 
<     public boolean getPropagated() {
<         return(propagated);
<     }
< }
---
> /*
> static char sccsid[] = "@(#)89  1.1  src/com/ibm/cim/CIMProperty.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:23";
> */
> 
> //
> // CIMProperty.java
> //
> // The contents of this file are subject to the SNIA Public License Version 1.0
> // (the "License"); you may not use this file except in compliance with the
> // License. You may obtain a copy of the License at
> //
> //	http://www.snia.org/resources/openSource.html
> //
> // Software distributed under the License is distributed on an "AS IS" basis,
> // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
> // License for the specific language governing rights and limitations
> // under the License.
> //
> // The Original Code is CIMProperty.java
> // 
> // The Initial Developer of the Original Code is David Simons.
> //
> // Contributor(s):
> //
> //
> // This source uses the Solaris WBEM APIs version 2.2. 
> // Synchronization will be maintained with the Solaris WBEM APIS,
> // which are being standardized through the Java Community Process.
> //
> //
> // $Id$
> //
> // $Log$
> // Revision 1.13  2001/04/15 23:59:33  davidsi
> // - Fixed <VALUE.ARRAY> generation for xml output.
> //
> // Revision 1.12  2000/11/09 17:36:05  davidsi
> // - Handle null datatypes for properties.
> //
> // Revision 1.11  2000/11/07 20:07:43  davidsi
> // - Preinitialize qualifiers to be an empty vector.
> //
> // Revision 1.10  2000/11/06 18:12:03  davidsi
> // - Added support for using java objects rather than strings to store
> //   CIM values.
> //
> // Revision 1.9  2000/08/16 05:59:52  shawn
> // merge P_TOMCAT31 branch
> //
> // Revision 1.8.6.1  2000/08/10 00:03:27  shawn
> // head merge
> //
> // Revision 1.8  2000/07/19 16:49:56  davidsi
> // - setQualifiers now throws an Error if the passed vector contains an
> //   object which is not a qualifier.
> //
> // Revision 1.7  2000/07/10 17:04:38  davidsi
> // - Fixed constructor to set property data type.
> //
> // Revision 1.6  2000/05/11 10:12:20  davidsi
> // - Fixed tabs.
> //
> // Revision 1.5  2000/05/07 13:30:52  davidsi
> // - Modified originClass so that an empty string is used when there is no
> //   origin class rather than a null value.
> //
> // Revision 1.4  2000/05/06 17:04:22  davidsi
> // - Modifications to bring classes inline with the SUN WBEM APIs 2.2.
> //
> // Revision 1.3  2000/04/09 13:19:15  davidsi
> // - Switched to StringBuffer (from String) for XML generation.
> //
> // Revision 1.2  2000/02/13 15:09:07  davidsi
> // - Added text to cover re-use of Solaris WBEM APIs.
> //
> // Revision 1.1.1.1  2000/02/06 16:41:03  davidsi
> // Initial version.
> //
> //
> //
> 
> 
> package com.ibm.cim;
> 
> 
> 
> import java.util.Vector;
> import java.net.MalformedURLException;
> import com.ibm.xml.*;
> 
> 
> public class CIMProperty  extends  CIMElement {
> 
> 
> 	// orginal class
> 	private String origClass;
> 
> 	//  CIMDataType
> 	private CIMDataType  dataType = null;
> 
> 	// qualifiers
> 	private Vector pQualifiers;
> 
> 	// CIMVlaue
> 	private CIMValue  value = null;
> 
> 	//propagated
> 	private boolean propagated = false;
> 
> 	//overriding property
> 	private String override = null;
> 
> 	//size
> 	private int sizeDataType = -1;
> 
> 	//constructor
> 	public CIMProperty(){
> 		pQualifiers = new Vector();
> 	}
> 
> 	//constructor
> 	public CIMProperty(String name){
> 		super(name);
> 		pQualifiers = new Vector();
> 	}
> 
> 	//constructor
> 	public CIMProperty(String name, CIMValue cVal){
> 		super(name);
> 		value = cVal;
> 		dataType = cVal.getType();
> 		pQualifiers = new Vector();
> 	}	
> 
> 
>  //
>     // CIMProperty
>     //
>     // Create a property using a XML definition
>     //
>     // @param node The node containing an XML definition of CIMProperty
>     //
>     public CIMProperty(org.w3c.dom.Node node) {
> 	XMLNode qnode=XMLNode.getXMLNode(node);
> 	String superClassName;
> 	String inClassName;
> 	pQualifiers = new Vector();
> 
> 	int token=qnode.getToken();
> 	if (token!=XMLNode.XML_ELEMENT_PROPERTY &&
> 	    token!=XMLNode.XML_ELEMENT_PROPERTY_ARRAY &&
> 	    token!=XMLNode.XML_ELEMENT_PROPERTY_REF ) 
> 		throw new java.lang.InstantiationError("Not a property node");
> 	try { 
> 	    String propName=qnode.getAttribute(XMLParameters.paramName);
> 	    String cimType=qnode.getAttribute(XMLParameters.paramTypeAssign);
> 	    String classOrigin=qnode.getAttribute(XMLParameters.paramClassOrigin);
> 	    String propagate=qnode.getAttribute(XMLParameters.paramPropagated);
> 
> 	    if (propName==null)
> 		throw new CIMException(CIMException.CIM_ERR_INVALID_PARAMETER,
> 		    "No property name");
> 	    //
> 	    // If no return data type, then property isn't properly defined
> 	    //
> 	    if (token==XMLNode.XML_ELEMENT_PROPERTY_REF) {
> 		String refClass=qnode.getAttribute(XMLParameters.paramReferenceClass);
> 		dataType=new CIMDataType(refClass);
> 	    } else  if (cimType!=null)		    
> 		dataType=CIMDataType.getDataType(cimType);
> 	    //
> 	    // Array type property
> 	    //
> 	    if (token==XMLNode.XML_ELEMENT_PROPERTY_ARRAY) {
> 		String arraySize=qnode.getAttribute(XMLParameters.paramArraySize);
> 		if (arraySize!=null) {
> 		    dataType=new CIMDataType(CIMDataType.findArrayType(
> 			    dataType.getType()),new Integer(arraySize).intValue());
> 		} else {
> 		    dataType=new CIMDataType(CIMDataType.findArrayType(dataType.getType()));	    
> 		}
> 	    }	    
> 		    
> 	    if (dataType==null) {
> 		new CIMException(CIMException.CIM_ERR_FAILED,"Property was null datatype "+propName);
> 	    }		    
> 		    
> 	    setName(propName);
> 	    if (classOrigin!=null)
> 		setOriginClass(classOrigin);
> 	    if (propagate!=null && propagate.equalsIgnoreCase("true"))
> 		setPropagated(true);
> 	    else
> 		setPropagated(false);
> 
> 	    //
> 	    // See if there are qualifiers
> 	    //
> 	    for(qnode=qnode.getChild();qnode!=null && qnode.getToken()==XMLNode.XML_ELEMENT_QUALIFIER;
> 		    qnode=qnode.getNext())
> 		pQualifiers.addElement(new CIMQualifier(qnode));
> 	    if (qnode!=null) {
> 		CIMValue propValue=new CIMValue(qnode);
> 			value=CIMOMCast.castDataType(propValue,dataType);
> 		}
> 	} catch (CIMException ce) {
> 	    throw new java.lang.InstantiationError(ce.toString());
> 	}   
>     }	
> 
>   /**
>    * isReference
>    *
>    * Returns TRUE if this property is a CIM reference
>   */
>  public boolean isReference(){
> 	  return(dataType.isReferenceType());
>   }
> 
> 	/**
> 	 *	Returns Qualifier vector
> 	 */
> 	public Vector getQualifiers() {
> 		return this.pQualifiers;
> 	}	
> 
> 	/**
> 	 *	Sets Qualifier vector
> 	 */
> 	public void setQualifiers(Vector qualVect) {
> 		if(qualVect != null) {
> 			for(int i =0; i<qualVect.size(); i++){
> 				Object obj =  qualVect.elementAt(i);
> 				if(!(obj instanceof CIMQualifier)){
> 					return;
> 				}	
> 			}	
> 			this.pQualifiers=qualVect;
> 		} 
> 	}	
> 
> 	/**
> 	 *	Returns original class of the property
> 	 */
> 	public String getOriginClass() {
> 		return origClass;
> 	}	
> 
> 
> 	/**
> 	 *	Sets original class of the property
> 	 */
> 	public void setOriginClass(String className) {
> 		origClass = className;
> 	}	
> 
> 
> 
> 	/**
> 	 *	Returns CIMValue of the property
> 	 */
> 	public CIMValue getValue() {
> 		return value;
> 	}	
> 
> 
> 	/**
> 	 *	Sets CIMValue of the property
> 	 */
> 	public void setValue(CIMValue val) {
> 		value = val;
> 
> 	}	
> 
> 
> 	/**
> 	 *	Returns CIMDataType of the property
> 	 */
> 	public CIMDataType getType() {
> 		return dataType;
> 	}	
> 
> 
> 	/**
> 	 *	Sets CIMDataType of the property
> 	 */
> 	public void setType(CIMDataType type) {
> 		dataType = type;
> 	}	
> 
> 
> 	/**
> 	 *	Returns true if CIMProperty is propogated
> 	 */
> 	public boolean getPropagated() {
> 		return propagated;
> 	}	
> 
> 
> 
> 	/**
> 	 *	sets the propogated field of CIMProperty 
> 	 */
> 	public void setPropagated(boolean propagate) {
> 		propagated = propagate;
> 	}	
> 
> 	/**
> 	 *	Returns overriding CIMProperty name
> 	 */
> 	public String getOverridingProperty() {
> 		return override;
> 	}	
> 
> 	/**
> 	 *	Sets overriding CIMProperty name
> 	 */
> 	public void setOverridingProperty(String overrideName) {
> 		override = overrideName;
> 	}	
> 	/**
> 	 *	Returns true if porperty is a key property
> 	 */
> 	public boolean isKey() {
> 		for (int i=0; i<pQualifiers.size(); i++){
> 			CIMQualifier qual = (CIMQualifier)pQualifiers.elementAt(i);
> 			if((qual.getName()).equalsIgnoreCase("key")){
> 				return true;
> 			}	
> 		}
> 		return false;
> 	}
> 
> 
> 
> 
> 	/**
> 	 *	Returns qualifier of specified name
> 	 */
> 	public CIMQualifier getQualifier(String qualifierName) {
> 		for (int i=0; i<pQualifiers.size(); i++){
> 			CIMQualifier qual = (CIMQualifier)pQualifiers.elementAt(i);
> 			if((qual.getName()).equalsIgnoreCase(qualifierName)){
> 				return qual;
> 			}	
> 		}
> 		return null;
> 	}
> 
> 
> 	/**
> 	 *	Sets qualifier
> 	 */
> 	public CIMQualifier setQualifier(CIMQualifier qual) {
> 		for (int i=0; i<pQualifiers.size(); i++){
> 			CIMQualifier q = (CIMQualifier)pQualifiers.elementAt(i);
> 			if((q.getName()).equalsIgnoreCase(qual.getName())){
> 				pQualifiers.setElementAt(qual,i);
> 				return qual;
> 			}	
> 		}
> 		//TODO throw exception
> 		return null;
> 	}	
> 
> 
> 	/**
> 	 *	Adds qualifier
> 	 */
> 	public void addQualifier(CIMQualifier qual) {
> 		for (int i=0; i<pQualifiers.size(); i++){
> 			CIMQualifier q = (CIMQualifier)pQualifiers.elementAt(i);
> 			if((q.getName()).equalsIgnoreCase(qual.getName())){
> 				return;
> 			}	
> 		}
> 		pQualifiers.addElement(qual);
> 	}	
> 
> 
> 
> 	/**
> 	 *	Removes qualifier
> 	 */
> 	public void removeQualifier(String qualName) {
> 		for (int i=0; i<pQualifiers.size(); i++){
> 			CIMQualifier qual = (CIMQualifier)pQualifiers.elementAt(i);
> 			if((qual.getName()).equalsIgnoreCase(qualName)){
> 				pQualifiers.removeElementAt(i);
> 			}	
> 		}
> 	}	
> 
> 
> 	/**
> 	 *	Clones CIMProperty object
> 	 * Includes qualifiers and classOrigin
> 	 */
> 	public Object clone() {
> 		return (clone(true,true));
> 	}	
> 
> 
> 	/**
> 	 * clones CIMProperty depending on input parameter
> 	 */
> 	public Object clone(boolean includeQualifier, boolean includeClassOrigin){
> 		CIMProperty cimProp = new CIMProperty();
> 		cimProp.setName(getName());
> 		cimProp.dataType = dataType;
> 		if(origClass != null) {
> 			cimProp.origClass = origClass;
> 		}	
> 
> 		if(override != null) {
> 			cimProp.override = override;
> 		}	
> 
> 		if( value != null) {
> 			cimProp.value = new CIMValue(value.getValue(), value.getType());
> 		}	
> 
> 		if(includeQualifier && pQualifiers != null ){
> 			cimProp.pQualifiers = new Vector();
> 			for(int i=0 ; i< pQualifiers.size(); i++){
> 				CIMQualifier cimQual =
> 						(CIMQualifier)(pQualifiers.elementAt(i));
> 				cimProp.pQualifiers.addElement(cimQual.clone());		
> 			}
> 		}
> 		return cimProp;
> 
> 	}
> 
> 
> 	//toMOF 
>     public String toMOF() {
> 	String ret;
> 	int i;
> 
> 	ret=new String();
> 	if (pQualifiers!=null && pQualifiers.size()>0) {
> 	    ret=ret.concat("[");
> 	    for(i=0;i<pQualifiers.size();i++) {
> 		CIMQualifier nq=((CIMQualifier)(pQualifiers.elementAt(i)));
> 		if (i>0)
> 		    ret=ret.concat(",");
> 		ret=ret.concat(nq.toMOF());
> 	    }
> 	    ret=ret.concat("]");
> 	}
> 
> 	
> 	ret=ret.concat(dataType.toMOF());
> 	ret=ret.concat(" ");
> 	ret=ret.concat(getName());
> 	if (value!=null) {
> 	    ret=ret.concat("=");
> 	    ret=ret.concat(value.toMOF());
> 	}
> 	ret=ret.concat(";\n");
> 	return(ret);
>     }
> 
>   public String toXml() throws MalformedURLException {
> 	return(toXml(false,true,true));
>     }
>     
>     //
>     // NOT SUN
>     //
>     
>     // toXml 
>     public String toXml(boolean localOnly,
> 			boolean includeQualifiers,
> 			boolean includeClassOrigin) throws MalformedURLException{
> 	StringBuffer text=new StringBuffer();
> 	boolean isArray=false;
> 	boolean isRef=false;
> 	String cimName=getName();
> 	
> 	if (cimName==null)
> 	    throw new MalformedURLException("property must have name");
> 
> 	//
> 	// If only local definitions are required and this is a propagated
> 	// property then nothing to return
> 	//
> 	if (localOnly && propagated)
> 	    return("");
> 	    
> 	//
> 	if (dataType!=null) {
> 	    isArray=dataType.isArrayType();
> 	    isRef=dataType.isReferenceType();
> 	    
> 	    if (isArray) {
> 		text=text.append("<PROPERTY.ARRAY NAME=\""+cimName+"\" "+
> 				 "TYPE=\""+
> 				CIMDataType.getPredefinedType(
> 					    CIMDataType.findSimpleType(
> 					    dataType.getType())).toXml()+"\" ");
> 		int size=dataType.getSize();
> 		if (size!=-1)	// i.e not unlimited
> 		    text=text.append("ARRAYSIZE=\""+size+"\" ");
> 	    } else if (isRef) {
> 		text=text.append("<PROPERTY.REFERENCE NAME=\""+cimName+"\" "+
> 				 "REFERENCECLASS=\""+dataType.getRefClassName()+"\" ");
> 	    } else
> 		text=text.append("<PROPERTY NAME=\""+cimName+"\" "+
> 				 "TYPE=\""+dataType.toXml()+"\" ");
> 	} else {
> 	    throw new MalformedURLException("Property "+cimName+" has no type defined");
> 	}
> 	
> 	if (includeClassOrigin && origClass!=null)
> 	    text=text.append("CLASSORIGIN=\""+origClass+"\" ");
> 	if (propagated==true)
> 	    text=text.append("PROPAGATED=\"true\" ");
>     
> 	text=text.append(">");	
> 
> 	if (pQualifiers!=null && includeQualifiers) {
> 	    for(int i=0;i<pQualifiers.size();i++) {
> 		CIMQualifier cq=(CIMQualifier)(pQualifiers.elementAt(i));
> 		text=text.append(cq.toXml());
> 	    }
> 	}
> 	
> 	if (value!=null) {
> 	    text=text.append(value.toXml());
> 	}
> 
> 	if (isArray)
> 	    text=text.append("</PROPERTY.ARRAY>");
> 	else if (isRef)
> 	    text=text.append("</PROPERTY.REFERENCE>");
> 	else
> 	    text=text.append("</PROPERTY>");
> 	
> 	return(text.toString());
> 
>     }
> 
> 	 //
>     // Returns a filtered version of the property
>     //
>     public CIMProperty filter(boolean localOnly,
> 		    boolean includeQualifiers)	{
> 	//
> 	// If only local definitions are required and this is a propagated
> 	// property then nothing to return
> 	//
> 	if (localOnly && propagated)
> 	    return(null);
> 		    
> 	CIMProperty cp=new CIMProperty();
> 	cp.dataType=dataType;
> 	cp.sizeDataType=sizeDataType;
> 	cp.setName(getName());
> 	if (cp.override!=null)
> 	    cp.override=override;
> 	if (cp.origClass!=null)
> 	    cp.origClass=origClass;
> 	if (value!=null)
> 	    cp.value=new CIMValue(value.getValue(),value.getType());
> 	cp.propagated=propagated;
> 		    
> 	//
> 	if (pQualifiers!=null && includeQualifiers) {
> 	    cp.pQualifiers=new Vector();
> 	    for(int i=0;i<pQualifiers.size();i++) {
> 		CIMQualifier cq=(CIMQualifier)(pQualifiers.elementAt(i));
> 		cp.pQualifiers.addElement(cq.clone());
> 	    }
> 	}
> 	return(cp);
>     }
> 
> 
> 	/**
> 	 * Compares identifier and value
> 	 * Creation date: (17/05/02 11:32:10 AM)
> 	 * @return boolean TRUE if this equals the passed element
> 	 * @param aProp java.lang.Object Another CIMProperty object
> 	 */
> 	 
> 	public boolean equals(Object anObj) {
> 		if(anObj instanceof CIMProperty) {
> 			CIMProperty prop = (CIMProperty) anObj;
> 			//compare identifiers
> 			if (super.equals(prop)) {
> 				//compares values.....
> 				if((getValue() != null)) {
> 					return ((prop.getValue() != null) && 
> 					( getValue().equals(prop.getValue())));
> 				}
> 				return prop.getValue() == null;
> 			}
> 		}
> 		return false;
> 	}	
> 
> 	
> }
> 
> 
> 
