#!/bin/sh

BASE=${1}
OS=`uname -s`
echo "`date`: Starting GUID check" > ${BASE}/log/installguid.txt

if [ "$OS" = "AIX" ]
  then
   installp -aX -d${BASE}/agent/guid/aix4-r1 tivoli.tivguid >  ${BASE}/log/guidInstallStdout.txt 2> ${BASE}/log/guidInstallStderr.txt
 elif [ "$OS" = "SunOS" ]
  then
    pkgadd -n -a ${BASE}/agent/guid/solaris2/guidadmin -d ${BASE}/agent/guid/solaris2/TIVguid.pkg TIVguid >  ${BASE}/log/guidInstallStdout.txt 2> ${BASE}/log/guidInstallStderr.txt
 elif [ "$OS" = "Linux" ]
  then
   rpm -U ${BASE}/agent/guid/linux-ix86/TIVguid.i386.rpm >  ${BASE}/log/guidInstallStdout.txt 2> ${BASE}/log/guidInstallStderr.txt
elif [ "$OS" = "HP-UX" ]
  then
    swinstall -x mount_all_filesystems=false -v -s ${BASE}/agent/guid/hp-ux_pa-risc/TIVGUID TIVGUID >  ${BASE}/log/guidInstallStdout.txt 2> ${BASE}/log/guidInstallStderr.txt
else
    echo "`date`: GUID check failed, platform ${OS} not supported" >> ${BASE}/log/installguid.txt
    exit 1
fi

echo "`date`: GUID check finished" >> ${BASE}/log/installguid.txt
