sqlcount = 11

##########################################################################
# Non dbms specific repository update script. 
# Processed by TrelliSoft.install.RepositoryAlter
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    ------------        ----------------------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text    
# {5}     long raw            image   
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
# {14}    <empty>             t_res_stat_dir.
# {15}    modify              alter column 
# {16}    <empty>             <empty> (interbase: type)
# {17}    <empty>             not null
###########################################################################

create table t_res_ldap_tree
  (tree_id           {0}            not null, 
   name              varchar(64)    not null,
   computer_id       {0}            not null) {22}
;

alter table t_res_domain 
  add tree_id  {0}   default -1 not null
;

alter table t_res_computer 
  {15}  trellisoft_name  {16} varchar(250) {17}
;

alter table t_res_computer 
  {15}  local_hostname   {16} varchar(255) {17}
;

alter table t_res_computer 
  {15}  network_name     {16} varchar(255) {17}
;

alter table t_res_filesystem
  add  scanning_comp_id  {0} default -1 not null
;

update t_res_filesystem
  set scanning_comp_id = computer_id
;
  
insert into t_alert_definition
  values (108, 'TrelliSoft', 'Nas Discovery', 'Nas Discovery Alert', 0, 
          'TrelliSoft', '1', 0, 8, 55, '0', -1, '0', '0',
          '0', '8', '0', ' ', -1, ' ')
;

insert into t_schedule
  values (108, 'TrelliSoft', 'Nas Discovery', 'Nas Discovery Schedule', 0,
          'TrelliSoft', '1', '3', 2000, 12, 10, 2, 0, '1', 
          '4', 1, '1', '1', '1', '1', '1', '1', 
          '1', '2', '1', ' ', ' ', 108, 'D', 1, 0)
;

create unique index t_res_ldap_tree_ix
  on t_res_ldap_tree (name)
;

create unique index t_res_domain_ix
  on t_res_domain (name)
;

