sqlcount = 14

##########################################################################
# Non dbms specific repository update script. 
# Processed by TrelliSoft.install.RepositoryAlter
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    ------------        ----------------------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text    
# {5}     long raw            image   
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
# {14}    <empty>             t_res_attribute
# {15}    modify              alter column
# {16}    <empty>             <empty>
# {17}    <empty>             not null
# {18}    <empty>             column
###########################################################################


alter table t_stat_computer
  add   owned_disk_cap		decimal(13)	default -1 not null
;

alter table t_stat_computer
  add   owned_disk_free_sp	decimal(13)	default -1 not null
;

alter table t_res_dev_access
  add  in_active char(1) default '0' not null
;

alter table t_res_filesystem
  add  export_name {23} default ' ' not null
;

create table t_stat_totals
  (statistic_type    {1}           not null,
   update_time       {3}           not null,
   fs_capacity       decimal(13)   not null,
   used_space        decimal(13)   not null,
   free_space        decimal(13)   not null,
   disk_capacity     decimal(13)   not null,
   disk_unallocated  decimal(13)   not null,
   total_directories {0}           not null,
   total_files       {0}           not null,
   total_filesystems {0}           not null,
   total_agents      {0}           not null,
   total_computers   {0}           not null,
   total_users       {0}           not null,
   total_disks       {0}           not null,
   all_alerts        {0}           not null,
   computer_alerts   {0}           not null,
   hard_disk_alerts  {0}           not null,
   filesystem_alerts {0}           not null,
   directory_alerts  {0}           not null,
   user_quota_alerts {0}           not null,
   grp_quota_alerts  {0}           not null,
   user_alerts       {0}           not null,
   computer_type     {1}           not null,  
   user_name         varchar(164)  not null,
   filesystem_name   varchar(764)  not null) {22}
;

create table t_res_pwd
  (resource_id       {0}           not null, 
   user_name         varchar(64)   not null,
   pwd               varchar(128)  not null) {22}
;


create unique index t_res_pwd_ix
  on t_res_pwd (resource_id)
;

create table t_snmp_community
  (community_id      {0}           not null, 
   snmp_community    varchar(64)   not null) {22}
;

create unique index t_snmp_ix
  on t_snmp_community (snmp_community)
;

delete from t_alert_definition where alert_id = 108
;
delete from t_schedule where schedule_id = 108
;
delete from t_runs where schedule_id = 108
;
delete from t_run_jobs where schedule_id = 108
;


