sqlcount = 32

##########################################################################
# Non dbms specific repository update script. 
# Processed by TrelliSoft.install.RepositoryAlter
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    ------------        ----------------------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text    
# {5}     long raw            image   
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
# {14}    <empty>             t_res_attribute
# {15}    modify              alter column
# {16}    <empty>             <empty>
# {17}    <empty>             not null
# {18}    <empty>             column
###########################################################################

alter table t_stat_time_dist
  add   range6_count		{0}		default 0 not null
;

alter table t_stat_time_dist
  add   range6_size		decimal(13)	default 0 not null
;

alter table t_stat_time_dist
  add   range7_count		{0}		default 0 not null
;

alter table t_stat_time_dist
  add   range7_size		decimal(13)	default 0 not null
;

alter table t_stat_time_dist
  add   range8_count		{0}		default 0 not null
;

alter table t_stat_time_dist
  add   range8_size		decimal(13)	default 0 not null
;

alter table t_stat_time_dist
  add   range9_count		{0}		default 0 not null
;

alter table t_stat_time_dist
  add   range9_size		decimal(13)	default 0 not null
;

alter table t_stat_time_dist
  add   range10_count		{0}		default 0 not null
;

alter table t_stat_time_dist
  add   range10_size		decimal(13)	default 0 not null
;

update t_stat_time_dist
   set range9_count = range5_count,
       range9_size  = range5_size
;

update t_stat_time_dist
   set
       range8_count = range4_count,
       range8_size  = range4_size
;

update t_stat_time_dist
   set range4_count  = 0,
       range4_size   = 0,
       range5_count  = 0,
       range5_size   = 0
;

alter table t_stat_time_hist
  add   range6_count		decimal(18) default 0 not null
;

alter table t_stat_time_hist
  add   range6_size		decimal(18)	default 0 not null
;

alter table t_stat_time_hist
  add   range7_count		decimal(18) default 0 not null
;

alter table t_stat_time_hist
  add   range7_size		decimal(18)	default 0 not null
;

alter table t_stat_time_hist
  add   range8_count		decimal(18)	default 0 not null
;

alter table t_stat_time_hist
  add   range8_size		decimal(18)	default 0 not null
;

alter table t_stat_time_hist
  add   range9_count		decimal(18)	default 0 not null
;

alter table t_stat_time_hist
  add   range9_size		decimal(18)	default 0 not null
;

alter table t_stat_time_hist
  add   range10_count	decimal(18)	default 0 not null
;

alter table t_stat_time_hist
  add   range10_size		decimal(18)	default 0 not null
;

update t_stat_time_hist
   set range9_count = range5_count,
       range9_size  = range5_size
;

update t_stat_time_hist
   set
       range8_count = range4_count,
       range8_size  = range4_size
;

update t_stat_time_hist
   set range4_count  = 0,
       range4_size   = 0,
       range5_count  = 0,
       range5_size   = 0
;

# Header and Total lines in CSV files

alter table t_batch_report
  add   headers			char(1)	default '0' not null
;

alter table t_batch_report
  add   totals			char(1)	default '0' not null
;

create table t_found_filesystem
  (computer_id       {0}            not null, 
   filesystem_id     {0}            not null, 
   scanning_comp_id  {0}            not null, 
   mount_point       {23}           not null) {22}
;

create unique index t_found_fs_ix
  on t_found_filesystem (computer_id, filesystem_id)
;

insert into t_found_filesystem
  select f.computer_id, f.filesystem_id, f.scanning_comp_id, f.mount_point
   from t_res_filesystem f, t_stat_computer c
   where f.computer_id = c.computer_id 
     and c.os_type >= 8
;

insert into t_res_share
  select d.tree_id, f.filesystem_id, 1, s.scan_time, s.removed_time, ' '
   from t_res_filesystem f, t_stat_computer c, t_res_domain d, t_res_share s
  where c.os_type = 8 and c.computer_id = f.computer_id
    and c.domain_id = d.domain_id and c.computer_id = s.resource_id
;
