sqlcount = 6

##########################################################################
# Non dbms specific repository update script. 
# Processed by TrelliSoft.install.RepositoryAlter
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    ------------        ----------------------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text    
# {5}     long raw            image   
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
# {14}    <empty>             t_res_attribute
# {15}    modify              alter column
# {16}    <empty>             <empty>
# {17}    <empty>             not null
# {18}    <empty>             column
# {19}    '4e'                0x4e   
###########################################################################

alter table t_res_computer
  add  product_states		{2}    default {19} not null
;

update t_res_computer
  set   product_states = (select product_states from t_res_agent a 
                           where a.computer_id = t_res_computer.computer_id)
  where computer_id in (select computer_id from t_res_agent)
;

alter table t_quota_definition
  {15}  name  {16}  varchar(64)  {17}
;

alter table t_quota_definition
  add filer_id {0} default -1 not null
;

alter table t_quota_definition
  add space_limit decimal(13) default -1 not null
;

alter table t_alert_definition
  {15}  name  {16}  varchar(64)  {17}
;

create unique index t_quota_def_ix1
  on t_quota_definition (creator, name)
;
