sqlcount = 28

##########################################################################
# Non dbms specific repository update script.
# Processed by TrelliSoft.install.RepositoryAlter
#
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    ------------        ----------------------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text
# {5}     long raw            image
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
# {14}    <empty>             t_res_attribute
# {15}    modify              alter column
# {16}    <empty>             <empty>
# {17}    <empty>             not null
# {18}    <empty>             column
###########################################################################


alter table t_res_database
  add   log_size     decimal(13) default 0 not null
;

alter table t_res_database
  add   logfreesp		decimal(13) default 0 not null
;

alter table t_res_database
  add   log_only_size   decimal(13) default 0 not null
;

alter table t_res_database
  add   mirror_size  decimal(13) default 0 not null
;

alter table t_res_database
  add   dbms_type		char(1)	default '0' not null
;

alter table t_res_tablespace
  add   log_size     decimal(13) default 0 not null
;

alter table t_res_tablespace
  add   log_only_size   decimal(13) default 0 not null
;

alter table t_res_tablespace
  add   logfreesp		decimal(13) default 0 not null
;

alter table t_res_tablespace
  add   mirror_size  decimal(13) default 0 not null
;

alter table t_res_tablespace
  add   last_dump_time {3} {21} 
;

alter table t_res_tablespace
  add   dbms_type		char(1)	default '0' not null
;

alter table t_res_datafile
  add   dbms_type		char(1)	default '0' not null
;

alter table t_res_log_group
  add   dbms_type		char(1)	default '0' not null
;

alter table t_res_logfile
  add   dbms_type		char(1)	default '0' not null
;

alter table t_res_logfile
  add   autoextend              char(1) default '0' not null
;

alter table t_res_logfile
  add   max_size	      {0}		default 0 not null
;

alter table t_res_logfile
  add   total_size      {0}		default 0 not null
;

alter table t_res_logfile
  add   growth	      {0}		default 0 not null
;

alter table t_res_logfile
  add   percent_growth  char(1)	default '0' not null
;

create table t_res_dbdevice
  (rdbms_id           	{0}             not null,
   device_id          	{0}             not null,
   name               	varchar(50)     not null,
   low                	{0}             not null,
   high               	{0}             not null,
   status             	{1}             not null,
   capacity           	decimal(13)     not null,
   freespace          	decimal(13)     not null,
   fragments            {0}             not null,
   discover_time      	{3}             not null,
   removed_time       	{3}             not null,
   filesystem_name    	{23}            not null,
   filesystem_id      	{0}             not null,
   file_type          	char(1)         not null,
   mirror_name        	{23}            not null,
   mirror_fs_id         {0}             not null,
   mirror_fs_type       char(1)         not null,
   mirror_capacity      decimal(13)     not null) {22}
;

create index t_res_dbdv_ix1
  on t_res_dbdevice (rdbms_id)
;

create index t_res_df_ix2
  on t_res_datafile (oid)
;

alter table t_res_table_filter
  add   table_db    varchar(128)         default ' ' not null
;

alter table t_alert_definition
  add   dbms_type   char(1)              default '0' not null
;

alter table t_alert_log
  add   dbms_type   char(1)              default '0' not null
;

alter table t_alert_log
  add   parent_id   {0}                  default -1 not null
;

alter table t_res_rdbms
  add   jdbc_driver  {23}	default '0' not null
;

alter table t_saved_report
  {15}  name  {16}  varchar(64)  {17}
;
