sqlcount = 9

##########################################################################
# Non dbms specific repository creation script. 
# Processed by TrelliSoft.install.RepositoryInstall
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle        MSSQL                      DB2
# ----    ------        -----                      ---
# {0}     decimal(10)   integer                    integer
# {1}     decimal(5)    smallint                   smallint
# {2}     raw(20)       varbinary(20)              varchar(20) for bit data
# {3}     date          datetime                   timestamp
# {4}     long          text                       long varchar
# {5}     long raw      image                      long varchar for bit data
# {6}     <empty>       case_mask varbinary(8)     <empty>
#                         default 0x00 not null,
# {7}     <empty>       case_mask varbinary(64)    <empty>
#                         default 0x00 not null,
# {8}     sysdate       current_timestamp          current timestamp
# {9}     '20'          ' '                        ' '
# {10}    <empty>       , case_mask                <empty>
# {11}    <empty>       0x00,                      <empty>
# {12}    float         float                      float
# {13}    raw(60)       varbinary(60)              varchar(60) for bit data
# {14}    <empty>       t_res_stat_dir.            <empty>
# {15}    modify        alter column               alter
# {16}    <empty>       <empty>                    set data type
# {17}    <empty>       not null                   <empty>
# {18}    column        column                     <empty>
# {19}    '4e'          0x4e                       x'4e'
# {20}    partition     partition                  "partition"
# {21}    default null  null                       <empty>
# {22}    <empty>       <empty>                    IN <tablspace>
###########################################################################

create table t_res_disk_array
  (disk_array_id     {0}          not null,
   manufacturer      varchar(64)  not null,
   model             varchar(128) not null,
   firmware_revision varchar(128) not null,
   cache_mb          {0}          not null,
   disk_capacity     decimal(13)  not null,
   disk_free_space   decimal(13)  not null,
   n_disks           {0}          not null,
   n_luns            {0}          not null,
   lun_capacity      decimal(13)  not null,
   last_probe_time   {3}          not null,
   probe_status      char(1)      not null,
   group_id          {0}          not null,
   probing_comp_id   {0}          not null) {22}
;

create unique index t_res_diskarr_ix1
  on t_res_disk_array (disk_array_id)
;

insert into t_group values
  (8, 'Tivoli', 'Default Storage Subsystem Group', 'The default storage subsystem group',
   0, 'Tivoli', '1', 77, 0)
;

alter table t_stat_disk
  add logical_disk_id {0} default -1 not null
;

alter table t_res_logical_disk
  add snap_source_id {0} default -1 not null
;

alter table t_res_logical_disk
  add is_vcmdb char(1) default '0' not null
;

alter table t_res_logical_disk
  add replication_mode char(1) default '0' not null
;

alter table t_res_logical_disk
  add not_exposed char(1) default '0' not null
;

alter table t_res_logical_disk
  add overhead decimal(13) default 0 not null
;
