sqlcount = 41

##########################################################################
# Non dbms specific repository creation script. 
# Processed by TrelliSoft.install.RepositoryInstall
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    ------------        ----------------------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text
# {5}     long raw            image
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
# {14}    <empty>             t_res_attribute
# {15}    modify              alter column
# {16}    <empty>             <empty>
# {17}    <empty>             not null
# {18}    column              column
# {19}    '4e'                0x4e
# {20}    partition           partition
# {21}    default null        null
# {22}    <empty>             <empty>
# {23}    varchar(256)        varchar(256)
# {24}    varchar(512)        varchar(512)
#
# Parm    Interbase Value                     Sybase Value
# ----    ---------------                     ------------
# {0}     integer                             integer
# {1}     smallint                            smallint
# {2}     varchar(20) character set octets    varbinary(21)
# {3}     timestamp                           datetime
# {4}     varchar(32000)                      text
# {5}     varchar(32000) character set octets image
# {6}     <empty>                             case_mask varbinary(9) default 0x00 not null,
# {7}     <empty>                             case_mask varbinary(65) default 0x00 not null,
# {8}     current_timestamp                   getdate()
# {9}     ' '                                 ' '
# {10}    <empty>                             , case_mask
# {11}    <empty>                             0x00,
# {12}    double precision                    float
# {13}    varchar(60) character set octets    varbinary(61)
# {14}    <empty>                             t_res_stat_dir.
# {15}    alter column                        modify
# {16}    type                                <empty>
# {17}    <empty>                             not null
# {18}    <empty>                             <empty>
# {19}    'N'                                 0x4e
# {20}    partition                           \"partition\"
# {21}    default null                        null
# {22}    <empty>                             <empty>
# {23}    varchar(256)                        varchar(256)
# {24}    varchar(512)                        varchar(512)
#
# Parm    UDB Values
# ----    ----------       
# {0}     integer        
# {1}     smallint
# {2}     varchar(20) for bit data            
# {3}     timestamp
# {4}     long varchar                
# {5}     long varchar for bit data            
# {6}     <empty>             
# {7}     <empty>             
# {8}     current timestamp             
# {9}     ' '                
# {10}    <empty>             
# {11}    <empty>             
# {12}    float               
# {13}    varchar(60) for bit data
# {14}    <empty>            
# {15}    alter              
# {16}    set data type             
# {17}    <empty>             
# {18}    <empty>              
# {19}    '4e'                
# {20}    \"partition\"
# {21}    <empty>        
# {22}    IN database.tablespace             
# {23}    varchar(256) or varchar(255)        
# {24}    varchar(512) or varchar(255)        
###########################################################################

create table t_identifier
  (id_type           {0}            not null, 
   identifier        {0}            not null) {22}
;

create table t_group
  (group_id          {0}            not null, 
   creator           varchar(32)    not null,
   name              varchar(32)    not null,
   description       varchar(64)    not null,
   last_modified     decimal(13)    not null,
   last_mod_user     varchar(32)    not null,
   share_mode        char(1)        not null,
   group_type        {1}            not null,
   flags             {0}            not null) {22}
;

create table t_res_computer
  (computer_id       {0}            not null,
   trellisoft_name   varchar(64)    not null,
   local_hostname    varchar(64)    not null,
   os_type           {1}            not null,
   network_name      varchar(64)    not null,
   domain_name       varchar(128)   not null,
   ip_address        varchar(15)    not null,
   hardware_id       {2}            not null,
   manufacturer      varchar(32)    not null,
   timezone          varchar(64)    not null,
   discovered_time   {3}            not null) {22}
;

create table t_res_server
  (server_id         {0}            not null,
   server_name       varchar(32)    not null,
   server_token      decimal(13)    not null,
   computer_id       {0}            not null,
   port_number       {0}            not null) {22}
;

create table t_res_agent
  (computer_id       {0}            not null,
   port_number       {0}            not null,
   server_id         {0}            not null,
   state             char(1)        not null,
   time_stamp        {3}            not null,
   processor_type    char(1)        not null,
   processor_number  {1}            not null,
   modification      char(1)        not null,
   product_states    {2}            not null,
   product_versions  {13}           not null) {22}
;

create table t_config_settings
  (snmp_server       varchar(128)   not null,
   snmp_port         {0}            not null,
   snmp_community    varchar(64)    not null,
   smtp_server       varchar(128)   not null,
   smtp_port         {0}            not null,
   smtp_reply_to     varchar(128)   not null,
   smtp_return       varchar(128)   not null,
   smtp_dflt_domain  varchar(128)   not null,
   retain_copies     {0}            not null,
   retain_days       {0}            not null) {22}
;

create table t_alert_log
  (alert_log_id       {0}           not null,
   alert_id           {0}           not null,
   notify_user        varchar(32)   not null,
   product_id         {0}           not null,
   computer_id        {0}           not null,
   resource_id        {0}           not null,
   resource_type      {1}           not null,
   alert_condition    {1}           not null,
   threshold_type     char(1)       not null,
   threshold_value    {0}           not null,
   violating_value    {0}           not null,
   previous_value     {0}           not null,
   violator_id        {0}           not null,
   violator_type      {1}           not null,
   first_alert_time   {3}           not null, 
   last_alert_time    {3}           not null, 
   alert_count        {0}           not null,
   state              char(1)       not null,
   script_computer_id {0}           not null,
   script_log_file    {23}  not null,
   script_name        varchar(64)   not null,
   msg                varchar(512)  not null) {22}
;

create table t_alert_definition
  (alert_id           {0}           not null,
   creator            varchar(32)   not null,
   name               varchar(32)   not null,
   description        varchar(64)   not null,
   last_modified      decimal(13)   not null,
   last_mod_user      varchar(32)   not null,
   enabled            char(1)       not null,
   product_id         {1}           not null,
   alert_type         {1}           not null,
   condition          {1}           not null,
   threshold_type     char(1)       not null,
   threshold_value    {0}           not null,
   snmp_trap          char(1)       not null,
   os_log             char(1)       not null,
   os_log_severity    char(1)       not null,
   syslog_facility    char(1)       not null,
   email              char(1)       not null,
   notify_on_login    varchar(32)   not null,
   script_computer_id {0}           not null,
   script_name        varchar(64)   not null) {22}
;

create table t_alert_email
  (alert_id          {0}            not null,
   subject           varchar(50)    not null,
   text              {4}            not null,
   recipients        {23}   not null,
   quota_violator    char(1)        not null) {22}
;

create table t_res_attribute
  (resource_id       {0}            not null, 
   resource_type     {1}            not null,  
   attribute_id      {0}            not null,
   attribute_type    {1}            not null,
   exclude           char(1)        not null) {22}
;

create table t_schedule
  (schedule_id       {0}            not null,
   creator           varchar(32)    not null,
   name              varchar(32)    not null,
   description       varchar(64)    not null,
   last_modified     decimal(13)    not null,
   last_mod_user     varchar(32)    not null,
   enabled           char(1)        not null,
   schedule_type     char(1)        not null,
   start_year        decimal(4)     not null,
   start_month       decimal(4)     not null,
   start_day         decimal(4)     not null,
   start_hour        decimal(4)     not null,
   start_minute      decimal(4)     not null,
   repeat_type       char(1)        not null,
   interval_type     char(1)        not null,
   interval_number   decimal(3)     not null,
   run_sunday        char(1)        not null,
   run_monday        char(1)        not null,
   run_tuesday       char(1)        not null,
   run_wednesday     char(1)        not null,
   run_thursday      char(1)        not null,
   run_friday        char(1)        not null,
   run_saturday      char(1)        not null,
   timezone_type     char(1)        not null,
   global_type       char(1)        not null,
   timezone          varchar(99)    not null,
   arguments         varchar(99)    not null,
   alert_id          {0}            not null,
   job_type          char(1)        not null,
   high_run_number   {0}            not null,
   computer_id       {0}            not null) {22}
;

create table t_runs
  (time_stamp        decimal(13)    not null,
   schedule_id       {0}            not null,
   run_number        {0}            not null,
   number_jobs       {0}            not null,
   successful_jobs   {0}            default -1  not null,
   finish_time       decimal(13)    default -1  not null,
   status            char(1)        default '2' not null) {22}
;

create table t_run_jobs
  (time_stamp        decimal(13)    not null,
   schedule_id       {0}            not null,
   sid_run_number    {0}            not null,
   computer_id       {0}            not null,
   job_run_number    {0}            not null,
   submit_status     {0}            default -1  not null,
   return_code       {0}            default -1  not null,
   process_id        {0}            default -1  not null,
   start_time        decimal(13)    default -1  not null,
   finish_time       decimal(13)    default -1  not null,
   log_file_name     {23}   default ' ' not null) {22}
;

create table t_user_preferences
  (user_id           varchar(32)   not null,   
   look_and_feel     varchar(64)   not null,
   max_panel_chain   {0}           not null,
   max_panels        {0}           not null,
   show_login_alerts char(1)       not null,
   tab_to_display    char(1)       not null,
   export_path       {23}  default ' ' not null) {22}
;

create table t_keys
  (license_key       varchar(32)   not null) {22}
;


########################################################################
# Index creates
########################################################################
create index t_alert_log_ix
  on t_alert_log (alert_id, computer_id, resource_id,
                  resource_type, alert_condition, 
                  violator_id, violator_type)
;

create unique index t_alert_log_ix2
  on t_alert_log (alert_log_id)
;
 
create unique index t_group_ix
  on t_group (creator, name)
;
 
create unique index t_res_server_ix
  on t_res_server (server_name)
;

create index t_res_agent_ix
  on t_res_agent (computer_id)
;

create unique index t_res_comp_ix1
  on t_res_computer (trellisoft_name)
;

create unique index t_res_comp_ix2
  on t_res_computer (manufacturer, hardware_id)
;

create unique index t_res_comp_ix3
  on t_res_computer (computer_id)
;

create index t_res_attr_ix
  on t_res_attribute (resource_id, resource_type)
;

create index t_res_attr_ix2
  on t_res_attribute (attribute_id, attribute_type)
;

create unique index t_schedule_ix
  on t_schedule (job_type, creator, name)
;

create unique index t_schedule_ix2
  on t_schedule (schedule_id)
;

create unique index t_alert_def_ix
  on t_alert_definition (alert_type, creator, name)
;

create unique index t_user_prefs_ix
  on t_user_preferences(user_id)
;

########################################################################
# Insert defaults
########################################################################
insert into t_identifier
  values (1, 300)
;
insert into t_identifier
  values (2, 1)
;
insert into t_identifier
  values (6, 1)
;

insert into t_config_settings
  values ('SNMP', 162, 'public', 'mailhost', 25, 'root@mailhost',
          'root@mailhost', 'company.com', 5, 90)
;
insert into t_group values
  (1, 'Tivoli', '{66}', '{26}',
   0, 'Tivoli', '1', 6, 0)
;
insert into t_group values
  (2, 'Tivoli', '{67}', 
   '{27}',
   0, 'Tivoli', '1', 8, 0)
;
insert into t_group values
  (3, 'Tivoli', '{68}', 
   '{28}', 0,
   'Tivoli', '1', 2, 0)
;
insert into t_group values
  (4, 'Tivoli', '{69}', 
   '{29}', 0,
   'Tivoli', '1', 0, 0)
;

insert into t_alert_definition
  values (100, 'Tivoli', '{70}', '{30}', 0, 
          'Tivoli', '1', 0, 8, 31, '0', -1, '0', '0',
          '0', '8', '0', ' ', -1, ' ')
;
insert into t_schedule
  values (100, 'Tivoli', '{70}', '{31}', 0,
          'Tivoli', '1', '3', 2000, 12, 10, 2, 30, '1', 
          '4', 1, '0', '0', '0', '0', '0', '0', 
          '0', '2', '1', ' ', ' ', 100, '6', 1, 0)
;

insert into t_alert_definition
  values (101, 'Tivoli', '{71}', 
          '{32}', 0,
          'Tivoli', '1', 0, 9, 27, '0', -1, '0', '0',
          '0', '8', '0', ' ', -1, ' ')
;
insert into t_schedule
  values (101, 'Tivoli', '{71}','{33}', 0, 
          'Tivoli',
          '1', '3', 2001, 01, 01, 3, 30, '2', '4', 1, '2',
          '2', '2', '2', '2', '2', '2', '2', 
          '1', ' ', ' ', 101, '5', 1, 0)
;

