sqlcount = 121
 
##########################################################################
# Non dbms specific repository creation script. 
# Processed by TrelliSoft.install.RepositoryInstall
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    -----------------   ----------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text    
# {5}     long raw            image   
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
###########################################################################

create table t_storm_settings
  (keep_removed_comp {1}          not null,  
   keep_removed_fs   {1}          not null,
   keep_removed_dir  {1}          not null,  
   keep_removed_dev  {1}          not null,  
   disk_daily_hist   {1}          not null,
   disk_weekly_hist  {1}          not null,
   disk_monthly_hist {1}          not null,
   dir_daily_hist    {1}          not null,
   dir_weekly_hist   {1}          not null,
   dir_monthly_hist  {1}          not null,
   ping_daily_hist   {1}          not null,
   ping_weekly_hist  {1}          not null,
   ping_monthly_hist {1}          not null,
   comp_daily_hist   {1}          not null,
   comp_weekly_hist  {1}          not null,
   comp_monthly_hist {1}          not null,
   fs_daily_hist     {1}          not null,
   fs_weekly_hist    {1}          not null,
   fs_monthly_hist   {1}          not null,
   disk_awre         char(1)      not null,
   disk_arre         char(1)      not null,
   disk_noerrrcvry   char(1)      not null,
   email_addr_rules  varchar(128) not null) {22}
;

create table t_res_comp_user
  (group_id          {0}          not null,
   user_id           {0}          not null,  
   computer_id       {0}          not null,  
   domain_id         {0}          not null,  
   sid_type          {1}          not null,  
   user_name         varchar(64)  not null,
   full_name         varchar(64)  not null,
   {6}
   discovered_time   {3}          not null) {22} 
;

create table t_res_user_group
  (group_id          {0}          not null,
   id                {0}          not null,  
   computer_id       {0}          not null,  
   domain_id         {0}          not null,  
   sid_type          {1}          not null,  
   group_name        varchar(64)  not null,
   {6}
   discovered_time   {3}          not null) {22} 
; 


create table t_res_controller
  (controller_id      {0}          not null,
   computer_id        {0}          not null,
   instance_number    {1}          not null,
   bus_number         {1}          not null,
   driver_name        varchar(16)  not null,
   driver_description varchar(128) not null,
   target             {1}          not null,
   controller_type    {1}          not null) {22} 
;

create table t_res_dev_access
  (controller_id      {0}          not null,
   device_id          {0}          not null,
   target             {1}          not null,
   lun                {1}          not null,
   path               {23} not null) {22} 
;

create table t_res_device
  (device_id         {0}          not null,
   manufacturer      varchar(42)  not null,
   model             varchar(40)  not null,
   serial_number     varchar(150) not null,
   firmware_rev      varchar(8)   not null,
   manufacture_date  {3}          not null,
   use_count         {1}          not null,
   device_type       {1}          not null,
   unsupported_model char(1)      not null,
   flags             {1}          not null,
   removable_medium  char(1)      not null,
   multi_port        char(1)      not null,
   discovered_time   {3}          not null) {22} 
;

create table t_stat_disk
  (disk_id            {0}          not null,
   heads              {0}          not null,
   cylinders          {0}          not null,
   rpm                {0}          not null,
   sector_size        {0}          not null, 
   sectors_avg_track  {0}          not null, 
   sectors_outr_track {0}          not null,
   sectors_innr_track {0}          not null,
   logical_block_size {0}          not null, 
   minutes_powered_on {0}          not null,
   write_protected    char(1)      not null,
   write_cache_enable char(1)      not null,
   read_cache_disable char(1)      not null, 
   auto_write_realloc char(1)      not null,
   auto_read_realloc  char(1)      not null, 
   no_error_recovery  char(1)      not null, 
   failure_predicted  char(1)      not null, 
   capacity           decimal(13)  not null,
   spare_blocks       {0}          not null, 
   volgroup_id        {0}          not null, 
   desired_awre       char(1)      not null, 
   desired_arre       char(1)      not null,
   desired_noerrrcvry char(1)      not null) {22} 
;

create table t_stat_disk_hist
  (disk_id            {0}          not null,
   statistic_time     {3}          not null,
   statistic_type     char(1)      not null,
   primary_defects    {0}          not null, 
   grown_defects      {0}          not null, 
   recovrd_wrt_errs   {0}          not null, 
   unrecovrd_wrt_errs {0}          not null,
   bytes_written      {12}         not null, 
   recovrd_rd_errs    {0}          not null, 
   unrecovrd_rd_errs  {0}          not null, 
   bytes_read         {12}         not null,
   recovrd_vfy_errs   {0}          not null, 
   unrecovrd_vfy_errs {0}          not null, 
   non_medium_errs    {0}          not null, 
   capacity           decimal(13)  not null,
   free_space         decimal(13)  not null, 
   temperature        {1}          not null) {22} 
;

create table t_res_logical_disk
  (logical_disk_id   {0}          not null,
   parent_logdisk_id {0}          not null,
   logical_disk_type char(1)      not null,
   capacity          decimal(13)  not null,
   mirror_count      char(1)      not null,
   is_swap           char(1)      not null,
   use_count         {1}          not null) {22} 
;

create table t_res_chunk_cllctn
  (collection_id     {0}          not null,
   logical_disk_id   {0}          not null,
   collection_type   char(1)      not null,
   seqno             {1}          not null,
   striping_size     {0}          not null) {22} 
;

create table t_res_chunk
  (disk_id           {0}          not null,
   collection_id     {0}          not null,
   logical_disk_id   {0}          not null,
   {20}	         {1}          not null,
   seqno             {1}          not null,
   has_db            char(1)      not null,
   unit_size         {0}          not null,
   chunk_size        decimal(13)  not null,
   offset            decimal(13)  not null) {22} 
;

create table t_res_share
  (computer_id       {0}          not null,
   resource_id       {0}          not null,
   resource_type     {1}          not null,
   scan_time         {3}          not null,
   removed_time      {3}          not null,
   path              {23}         not null) {22} 
;

create table t_res_export
  (export_id         {0}          not null,
   computer_id       {0}          not null,  
   protocol          char(1)      not null, 
   path              {23}         not null, 
   export_name       {23}         not null,
   discovered_time   {3}          not null) {22} 
;

create table t_res_directory
  (group_id          {0}          not null,
   res_directory_id  {0}          not null,  
   computer_id       {0}          not null,
   path              varchar(240) not null) {22} 
;

create table t_res_filesystem
  (filesystem_id     {0}          not null,
   computer_id       {0}          not null,
   group_id          {0}          not null,
   logical_disk_id   {0}          not null,
   log_disk_id       {0}          not null,
   maxfiles          {0}          not null,
   used_inodes       decimal(12)  not null,
   free_inodes       decimal(12)  not null,
   physical_size     decimal(13)  not null,
   capacity          decimal(13)  not null,
   used_space        decimal(13)  not null,
   free_space        decimal(13)  not null,
   file_count        decimal(12)  not null,
   directory_count   decimal(12)  not null,
   last_scan_time    {3}          not null,
   filesystem_type   {1}          not null,
   use_count         {1}          not null,
   mount_point       {23}         not null,
   discovered_time   {3}          not null) {22} 
;

create table t_stat_definition
  (statistic_id      {0}          not null,
   creator           varchar(32)  not null,  
   name              varchar(32)  not null,
   description       varchar(64)  not null,
   last_modified     decimal(13)  not null,
   last_mod_user     varchar(32)  not null,
   stat_type         char(1)      not null,
   alert_id          {0}          not null,
   largest_files     {1}          not null,
   largest_dirs      {1}          not null,
   least_accessed    {1}          not null,
   oldest_backup     {1}          not null,
   largest_orphans   {1}          not null,
   oldest_orphans    {1}          not null,
   summary           char(1)      not null,
   size_distribution char(1)      not null,
   group_by_owner    char(1)      not null,
   group_by_group    char(1)      not null,
   group_by_access   char(1)      not null,
   group_by_mod      char(1)      not null,
   group_by_creation char(1)      not null,
   group_by_backup   char(1)      not null,
   daily_retention   {1}          not null,
   weekly_retention  {1}          not null,
   monthly_retention {1}          not null,
   text              {5}          not null) {22} 
;

create table t_res_domain
  (domain_id         {0}          not null,
   name              varchar(128) not null) {22} 
;

create table t_stat_computer
  (computer_id       {0}          not null,
   domain_id         {0}          not null,
   group_id          {0}          not null,
   manufacturer      varchar(64)  not null,
   model             varchar(64)  not null,
   serial_number     varchar(64)  not null,
   os_type           {1}          not null,
   os_version        varchar(32)  not null,
   processor_type    varchar(32)  not null,
   processor_count   {1}          not null,
   processor_speed   {1}          not null,
   ram               {0}          not null,
   swap_space        {0}          not null,
   disk_capacity     decimal(13)  not null,
   fs_free_space     decimal(13)  not null,
   disk_free_space   decimal(13)  not null,
   last_boot_time    {3}          not null,
   probe_status      char(1)      not null,
   last_probe_time   {3}          not null) {22} 
;

create table t_stat_ping_hist
  (computer_id        {0}          not null,
   statistic_type     char(1)      not null,
   monitor_start      {3}          not null,
   monitor_end        {3}          not null,
   transmitted        {0}          not null,
   received           {0}          not null,
   damaged            {0}          not null,
   min_transit_time   {0}          not null, 
   max_transit_time   {0}          not null, 
   avg_transit_time   decimal(13)  not null) {22} 
;

create table t_stat_comp_hist
  (computer_id        {0}          not null,
   statistic_type     char(1)      not null,
   monitor_start      {3}          not null,
   monitor_end        {3}          not null,
   power_cycles       {0}          not null,
   down_time          {0}          not null) {22} 
;

create table t_stat_summary
  (filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   file_count        {0}          not null,
   directory_count   {0}          not null,
   total_size        decimal(13)  not null) {22} 
;

create table t_res_stat_dir
  (directory_id      {0}          not null,
   res_directory_id  {0}          not null,
   dir_group_id      {0}          not null) {22} 
;

create table t_stat_directory
  (directory_id      {0}          not null,
   filesystem_id     {0}          not null,
   name              {23}         not null,
   owner_id          {0}          not null,
   group_id          {0}          not null,
   creation_time     {3}          not null,
   access_time       {3}          not null,
   modification_time {3}          not null,
   attributes        {0}          not null,
   scan_time         {3}          not null,
   removed_time      {3}          not null,
   {7}
   discovered_time   {3}          not null) {22} 
;

create table t_stat_large_dir
  (filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   name              {23}         not null,
   owner_id          {0}          not null,
   group_id          {0}          not null,
   creation_time     {3}          not null,
   access_time       {3}          not null,
   modification_time {3}          not null,
   attributes        {0}          not null,
   file_count        {0}          not null,
   directory_count   {0}          not null,
   total_size        decimal(13)  not null,
   largest           decimal(13)  not null,
   second_largest    decimal(13)  not null,
   range1_count      {0}          not null,
   range1_size       decimal(13)  not null,
   range2_count      {0}          not null,
   range2_size       decimal(13)  not null,
   range3_count      {0}          not null,
   range3_size       decimal(13)  not null,
   range4_count      {0}          not null,
   range4_size       decimal(13)  not null,
   range5_count      {0}          not null,
   range5_size       decimal(13)  not null,
   range6_count      {0}          not null,
   range6_size       decimal(13)  not null,
   range7_count      {0}          not null,
   range7_size       decimal(13)  not null,
   range8_count      {0}          not null,
   range8_size       decimal(13)  not null) {22} 
;

create table t_stat_file
  (filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   statistic_type    char(1)      not null,
   name              {24}         not null,
   owner_id          {0}          not null,
   group_id          {0}          not null,
   logical_size      decimal(16)  not null,
   physical_size     decimal(13)  not null,
   creation_time     {3}          not null,
   access_time       {3}          not null,
   modification_time {3}          not null,
   attributes        {0}          not null) {22} 
;

create table t_stat_size_dist
  (filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   range1_count      {0}          not null,
   range1_size       decimal(13)  not null,
   range2_count      {0}          not null,
   range2_size       decimal(13)  not null,
   range3_count      {0}          not null,
   range3_size       decimal(13)  not null,
   range4_count      {0}          not null,
   range4_size       decimal(13)  not null,
   range5_count      {0}          not null,
   range5_size       decimal(13)  not null,
   range6_count      {0}          not null,
   range6_size       decimal(13)  not null,
   range7_count      {0}          not null,
   range7_size       decimal(13)  not null,
   range8_count      {0}          not null,
   range8_size       decimal(13)  not null) {22} 
;

create table t_stat_time_dist
  (filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   statistic_type    char(1)      not null,
   statistic_time    {3}          not null,
   avg_age           {12}         not null,
   range1_count      {0}          not null,
   range1_size       decimal(13)  not null,
   range2_count      {0}          not null,
   range2_size       decimal(13)  not null,
   range3_count      {0}          not null,
   range3_size       decimal(13)  not null,
   range4_count      {0}          not null,
   range4_size       decimal(13)  not null,
   range5_count      {0}          not null,
   range5_size       decimal(13)  not null) {22} 
;

create table t_stat_time_hist
  (filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   statistic_type    char(1)	    not null,
   statistic_time    {3}          not null,
   report_type       char(1)      not null,
   accum_count       {1}          not null,
   range1_count      decimal(18)  not null,
   range1_size       decimal(18)  not null,
   range2_count      decimal(18)  not null,
   range2_size       decimal(18)  not null,
   range3_count      decimal(18)  not null,
   range3_size       decimal(18)  not null,
   range4_count      decimal(18)  not null,
   range4_size       decimal(18)  not null,
   range5_count      decimal(18)  not null,
   range5_size       decimal(18)  not null) {22} 
;

create table t_stat_user
  (user_id           {0}          not null,
   filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   file_count        {0}          not null,
   directory_count   {0}          not null,
   total_size        decimal(13)  not null,
   largest           decimal(13)  not null,
   second_largest    decimal(13)  not null,
   range1_count      {0}          not null,
   range1_size       decimal(13)  not null,
   range2_count      {0}          not null,
   range2_size       decimal(13)  not null,
   range3_count      {0}          not null,
   range3_size       decimal(13)  not null,
   range4_count      {0}          not null,
   range4_size       decimal(13)  not null,
   range5_count      {0}          not null,
   range5_size       decimal(13)  not null,
   range6_count      {0}          not null,
   range6_size       decimal(13)  not null,
   range7_count      {0}          not null,
   range7_size       decimal(13)  not null,
   range8_count      {0}          not null,
   range8_size       decimal(13)  not null) {22} 
;

create table t_stat_group
  (group_id          {0}          not null,
   filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   file_count        {0}          not null,
   directory_count   {0}          not null,
   total_size        decimal(13)  not null,
   largest           decimal(13)  not null,
   second_largest    decimal(13)  not null,
   range1_count      {0}          not null,
   range1_size       decimal(13)  not null,
   range2_count      {0}          not null,
   range2_size       decimal(13)  not null,
   range3_count      {0}          not null,
   range3_size       decimal(13)  not null,
   range4_count      {0}          not null,
   range4_size       decimal(13)  not null,
   range5_count      {0}          not null,
   range5_size       decimal(13)  not null,
   range6_count      {0}          not null,
   range6_size       decimal(13)  not null,
   range7_count      {0}          not null,
   range7_size       decimal(13)  not null,
   range8_count      {0}          not null,
   range8_size       decimal(13)  not null) {22} 
;

create table t_stat_user_hist
  (user_id           {0}          not null,
   filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   statistic_type    char(1)      not null,
   statistic_time    {3}          not null,
   accum_count       {1}          not null,
   file_count        decimal(18)  not null,
   total_size        decimal(18)  not null) {22} 
;

create table t_stat_group_hist
  (group_id          {0}          not null,
   filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   statistic_type    char(1)      not null,
   statistic_time    {3}          not null,
   accum_count       {1}          not null,
   file_count        decimal(18)  not null,
   total_size        decimal(18)  not null) {22} 
;

create table t_stat_space_hist
  (filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   statistic_type    char(1)      not null,
   statistic_time    {3}          not null,
   accum_count       {1}          not null,
   file_count        decimal(18)  not null,
   total_size        decimal(18)  not null) {22} 
;

create table t_stat_fs_hist
  (filesystem_id     {0}          not null,
   statistic_type    char(1)      not null,
   statistic_time    {3}          not null,
   accum_count       {1}          not null,
   file_count        decimal(18)  not null,
   capacity          decimal(18)  not null, 
   free_space        decimal(18)  not null) {22} 
;

create table t_quota_definition
  (quota_id          {0}          not null,
   creator           varchar(32)  not null,
   name              varchar(32)  not null,
   description       varchar(64)  not null,
   last_modified     decimal(13)  not null,
   last_mod_user     varchar(32)  not null,
   quota_type        {1}          not null,
   user_quota        char(1)      not null,
   alert_id          {0}          not null,
   statistic_id      {0}          not null) {22} 
;

create table t_stat_scan_spoor
  (schedule_id       {0}          not null,
   filesystem_id     {0}          not null,
   statistic_id      {0}          not null,
   dir_group_id      {0}          not null) {22} 
;

create table t_report_prefs
  (trellisoft_user   varchar(32)  not null,
   report_type       {0}          not null,
   profile_id        {0}          not null,
   fs_max_rows       {0}          not null,
   fs_grp_max_rows   {0}          not null,
   dir_max_rows      {0}          not null,
   dir_grp_max_rows  {0}          not null,
   computer_max_rows {0}          not null,
   comp_grp_max_rows {0}          not null,
   user_max_rows     {0}          not null,
   group_max_rows    {0}          not null) {22} 
;

create table t_found_computer
  (found_computer_id {0}           not null,
   name              varchar(64)   not null,
   domain_name       varchar(128)  not null,
   ip_address        varchar(23)   not null,
   os_type           {1}           not null,
   discovery_method  {1}           not null,
   name_is_local     char(1)       not null,
   when_discovered   {3}           not null,
   times_missing     {1}           not null) {22} 
;

create table t_aggregator
  (last_weekly       {3}           not null,
   last_monthly      {3}           not null) {22} 
;

create table t_saved_report
  (report_id         {0}          not null,
   creator           varchar(32)  not null,  
   name              varchar(32)  not null,
   description       varchar(64)  not null,
   last_modified     decimal(13)  not null,
   last_mod_user     varchar(32)  not null,
   definition        {5}          not null) {22} 
;
 
create table t_batch_report
  (report_id         {0}          not null,
   file_mask         varchar(128) not null,
   report_type       char(1)      not null,
   script_name       varchar(64)  not null,
   definition        {5}          not null) {22} 
;

create unique index t_res_ctlr_ix
  on t_res_controller (computer_id, controller_id)
;

create index t_res_da_ix
  on t_res_dev_access (controller_id)
;

create unique index t_res_dev_ix
  on t_res_device (device_id)
;
 
create unique index t_res_dev_ix2
  on t_res_device (manufacturer, serial_number)
;

create unique index t_stat_disk_ix
  on t_stat_disk (disk_id)
;

create unique index t_res_fs_ix
  on t_res_filesystem (filesystem_id)
;

create index t_res_fs_ix2
  on t_res_filesystem (group_id)
;

create index t_res_fs_ix3
  on t_res_filesystem (logical_disk_id)
;

create index t_res_fs_ix4
  on t_res_filesystem (computer_id)
;

create unique index t_res_comp_user_ix
  on t_res_comp_user (user_name, computer_id, domain_id, sid_type {10})
;

create unique index t_res_user_grp_ix
  on t_res_user_group (group_name, computer_id, domain_id, sid_type {10})
;

create unique index t_res_logdisk_ix
  on t_res_logical_disk (logical_disk_id, parent_logdisk_id)
;

create unique index t_res_coll_ix
  on t_res_chunk_cllctn (collection_id)
;

create index t_res_chunk_ix1
  on t_res_chunk (logical_disk_id, collection_id)
;

create index t_res_chunk_ix2
  on t_res_chunk (disk_id, offset)
;

create unique index t_res_share_ix
  on t_res_share (computer_id, resource_type, resource_id)
;
 
create index t_res_dir_ix
  on t_res_directory (group_id)
;

create index t_res_dir_ix2
  on t_res_directory (computer_id)
;

create unique index t_stat_cmp_ix
  on t_stat_computer (computer_id)
;

create unique index t_stat_summary_ix
  on t_stat_summary (filesystem_id, statistic_id)
;

create index t_res_stat_dir_ix
  on t_res_stat_dir (directory_id)
;

create unique index t_stat_dir_ix
  on t_stat_directory (directory_id)
;

create index t_stat_dir_ix2
  on t_stat_directory (filesystem_id)
;

create index t_stat_ldir_ix
  on t_stat_large_dir (filesystem_id, statistic_id)
;

create index t_stat_file_ix
  on t_stat_file (filesystem_id, statistic_id,
                             statistic_type)
;

create index t_stat_tdist_ix
  on t_stat_time_dist (filesystem_id, statistic_id, statistic_type)
;

create index t_stat_thist_ix
  on t_stat_time_hist (filesystem_id, statistic_id, statistic_type)
; 


create unique index t_stat_def_ix
  on t_stat_definition (creator, name)
;

create index t_stat_def_ix2
  on t_stat_definition (statistic_id)
;

create unique index t_stat_user_ix
  on t_stat_user (filesystem_id, statistic_id, user_id)
;

create unique index t_stat_group_ix
  on t_stat_group (filesystem_id, statistic_id, group_id)
;

create index t_stat_usr_hist_ix
  on t_stat_user_hist (filesystem_id, statistic_id, 
                                  user_id, statistic_type)
;

create index t_stat_grp_hist_ix
  on t_stat_group_hist (filesystem_id, statistic_id,
                                   group_id, statistic_type)
; 


create index t_stat_sp_hist_ix
  on t_stat_space_hist (filesystem_id, statistic_id,
                                   statistic_type)
; 


create index t_stat_fs_hist_ix
  on t_stat_fs_hist (filesystem_id, statistic_type)
; 


create index t_scan_spoor_ix1
  on t_stat_scan_spoor (filesystem_id, schedule_id)
;

create unique index t_report_prefs_ix
  on t_report_prefs (trellisoft_user, report_type)
;

create unique index t_saved_report_ix
  on t_saved_report (creator, name)
;

create index t_saved_report_ix2
  on t_saved_report (report_id)
;

create index t_batch_report_ix
  on t_batch_report (report_id)
;

create index t_run_jobs_ix
  on t_run_jobs (schedule_id, sid_run_number)
;

create unique index t_run_jobs_ix2
  on t_run_jobs (job_run_number)
;

create index t_size_dist_ix
  on t_stat_size_dist (filesystem_id, statistic_id)
;

create index t_disk_hist_ix
  on t_stat_disk_hist (disk_id, statistic_type)
;

create index t_comp_hist_ix
  on t_stat_comp_hist (computer_id, statistic_type)
;

create index t_ping_hist_ix
  on t_stat_ping_hist (computer_id, statistic_type)
;

insert into t_storm_settings
   values (30, 14, 7, 14, 6, 4, 2, 6, 4, 2, 6, 4, 2, 6, 4, 2, 6, 4, 2, '1', '1', '1',
           'LASTNAME + SUBSTRING(FIRSTNAME, 0, 1)')
;
insert into t_res_comp_user
   values (-1, -1, -1, -1, 8, ' ', ' ', {11} {8})
;
insert into t_res_user_group
   values (-1, -1, -1, -1, 8, ' ', {11} {8})
;
insert into t_stat_definition values
   (10, 'Tivoli', '{81}',
    '{44}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 0, '1', '0', '0', '0', '0', '0', '0', '0', 7, 4, 2, {9})
;
insert into t_stat_definition values
   (11, 'Tivoli', '{80}', 
    '{45}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 0, '0', '1', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;
insert into t_stat_definition values
   (12, 'Tivoli', '{82}',
    '{34}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 0, '0', '0', '1', '0', '0', '0', '0', '0', 7, 4, 2, {9})
;
insert into t_stat_definition values
   (13, 'Tivoli', '{83}',
    '{46}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 0, '0', '0', '0', '1', '0', '0', '0', '0', 7, 4, 2, {9})
;
insert into t_stat_definition values
   (14, 'Tivoli', '{84}',
    '{47}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 0, '0', '0', '0', '0', '1', '0', '0', '0', 7, 4, 3, {9})
;
insert into t_stat_definition values
   (15, 'Tivoli', '{85}',
    '{48}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 0, '0', '0', '0', '0', '0', '1', '0', '0', 7, 4, 3, {9})
;
insert into t_stat_definition values
   (16, 'Tivoli', '{86}',
    '{49}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 0, '0', '0', '0', '0', '0', '0', '1', '0', 7, 4, 3, {9})
;
insert into t_stat_definition values
   (17, 'Tivoli', '{87}',
    '{50}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 0, '0', '0', '0', '0', '0', '0', '0', '1', 7, 4, 3, {9})
;
insert into t_stat_definition values
   (18, 'Tivoli', '{88}',
    '{51}',
    0, 'Tivoli', '2', -1,
    20, 0, 0, 0, 0, 0, '0', '0', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;
insert into t_stat_definition values
   (19, 'Tivoli', '{89}',
    '{35}',
    0, 'Tivoli', '2', -1,
    0, 20, 0, 0, 0, 0, '0', '0', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;
insert into t_stat_definition values
   (20, 'Tivoli', '{90}',
    '{52}',
    0, 'Tivoli', '2', -1,
    0, 0, 20, 0, 0, 0, '0', '0', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;
insert into t_stat_definition values
   (21, 'Tivoli', '{91}',
    '{53}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 20, 0, 0, '0', '0', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;
insert into t_stat_definition values
   (22, 'Tivoli', '{92}',
    '{54}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 20, 0, '0', '0', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;
insert into t_stat_definition values
   (23, 'Tivoli', '{93}',
    '{55}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 20, '0', '0', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;
insert into t_stat_definition values
   (24, 'Tivoli', '{94}',
    '{56}',
    0, 'Tivoli', '2', -1,
    0, 0, 0, 0, 0, 0, '1', '0', '0', '0', '0', '0', '0', '0', 7, 4, 2, {9})
;
insert into t_alert_definition values
   (60, 'Tivoli', '{95}', '{57}', 0,
    'Tivoli', '1', 0, 5, 22, '3', 1, '0', '0', '0', '8', '0', ' ', -1, ' ')
;
insert into t_stat_definition values
   (60, 'Tivoli', '{96}',
    '{58}',
    0, 'Tivoli', '4', 60,
    200, 0, 0, 0, 0, 0, '1', '0', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;
insert into t_alert_definition values
   (61, 'Tivoli', '{97}', '{59}', 0,
    'Tivoli', '1', 0, 5, 22, '3', 1, '0', '0', '0', '8', '0', ' ', -1, ' ')
;
insert into t_stat_definition values
   (61, 'Tivoli', '{97}',
    '{60}',
    0, 'Tivoli', '4', 61,
    200, 0, 0, 0, 0, 0, '1', '0', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;
insert into t_alert_definition values
   (62, 'Tivoli', '{98}', '{61}', 0,
    'Tivoli', '1', 0, 5, 22, '3', 1, '0', '0', '0', '8', '0', ' ', -1, ' ')
;
insert into t_stat_definition values
   (62, 'Tivoli', '{98}',
    '{62}',
    0, 'Tivoli', '4', 62,
    200, 0, 0, 0, 0, 0, '1', '0', '0', '0', '0', '0', '0', '0', 0, 0, 0, {9})
;

insert into t_alert_definition values
   (102, 'Tivoli', '{99}', '{63}', 0, 'Tivoli',
    '1', 0, 2, 15, '1', 4, '0', '0', '0', '8', '0', ' ', -1, ' ')
;
insert into t_schedule values
   (102, 'Tivoli', '{99}', '{64}', 0,
    'Tivoli', '1', '3', 2000, 6, 29, 11, 24, '1', '1', 30, '0', '0', '0',
    '0', '0', '0', '0', '2', '1', ' ', '7 0', 102, '2', 1, 0)
;
insert into t_res_attribute values
   (4, 0, 102, 17, '0')
;

insert into t_alert_definition values
   (103, 'Tivoli', '{100}', '{40}', 0, 'Tivoli',
    '1', 0, 0, 0, '0', -1, '0', '0', '0', '8', '0', ' ', -1, ' ')
;
insert into t_schedule values
   (103, 'Tivoli', '{100}', '{41}', 0,
    'Tivoli', '1', '3', 2000, 6, 29, 1, 45, '1', '3', 1, '0', '0', '0',
    '0', '0', '0', '0', '1', '1', ' ', ' ', 103, '3', 1, 0)
;
insert into t_res_attribute values
   (4, 0, 103, 16, '0')
;

insert into t_alert_definition values
   (104, 'Tivoli', '{101}', '{42}', 0, 'Tivoli', '1', 0,
    1, 11, '0', -1, '0', '0', '0', '8', '0', ' ', -1, ' ')
;
insert into t_schedule values
   (104, 'Tivoli', '{101}', '{65}', 0,
    'Tivoli', '1', '3', 2000, 6, 29, 2, 15, '1', '3', 1, '0', '0', '0',
    '0', '0', '0', '0', '1', '1', ' ', ' ', 104, '1', 1, 0)
;
insert into t_res_attribute values
   (3, 2, 104, 15, '0')
;
insert into t_res_attribute values
   (10, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (11, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (12, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (14, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (15, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (16, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (17, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (18, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (19, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (20, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (21, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (22, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (23, 18, 104, 15, '0')
;
insert into t_res_attribute values
   (24, 18, 104, 15, '0')
;