sqlcount = 1

##########################################################################
# Non dbms specific repository update script. 
# Processed by TrelliSoft.install.RepositoryAlter
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    ------------        ----------------------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text    
# {5}     long raw            image   
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
# {14}    <empty>             t_res_attribute
###########################################################################

create table t_cb_settings
  (report_type        {0}             not null,
   osuser_report      char(1)         not null,
   osuser_profile     {0}             not null,
   osuser_cost        {12}            not null,
   osuser_unit        {0}             not null,
   oscomp_report      char(1)         not null,
   oscomp_cost        {12}            not null,
   oscomp_unit        {0}             not null,
   dbuser_report      char(1)         not null,
   dbuser_profile     {0}             not null,
   dbuser_cost        {12}            not null,
   dbuser_unit        {0}             not null,
   dbtbsp_report      char(1)         not null,
   dbtbsp_cost        {12}            not null,
   dbtbsp_unit        {0}             not null
   ) {22}
;
